#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 0, std140) uniform type_MLAAConstants
{
    vec4 g_xRTMetrics;
} MLAAConstants;

layout(set = 0, binding = 3) uniform sampler g_xBilinearClamp;
layout(set = 1, binding = 48) uniform TEXTURE_2D g_xEdgesTexture;
layout(set = 1, binding = 49) uniform TEXTURE_2D g_xAreaTexture;
layout(set = 1, binding = 50) uniform TEXTURE_2D g_xSearchTexture;

layout(location = 0) in vec2 in_var_TEXCOORD0;
layout(location = 1) in vec2 in_var_TEXCOORD1;
layout(location = 2) in vec4 in_var_TEXCOORD2[3];
layout(location = 0) out vec4 out_var_SV_Target;

vec4 _142;
vec2 _143;
vec4 _144;
vec3 _145;
vec2 _146;

void main()
{
    vec4 _159 = SAMPLE_TEXTURE(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), in_var_TEXCOORD0);
    vec2 _160 = _159.xy;
    vec4 _522;
    vec2 _523;
    if (_159.y > 0.0)
    {
        vec2 _203;
        vec4 _204;
        if (_159.x > 0.0)
        {
            vec3 _177 = vec3(MLAAConstants.g_xRTMetrics.xy, 1.0);
            vec2 _179;
            vec4 _182;
            _179 = _143;
            _182 = vec4(in_var_TEXCOORD0, -1.0, 1.0);
            float _184;
            for (;;)
            {
                _184 = _182.z;
                if ((_184 < 7.0) && (_182.w > 0.89999997615814208984375))
                {
                    vec3 _23 = fma(_177, vec3(-1.0, 1.0, 1.0), _182.xyz);
                    vec2 _180 = TEXTURE_LOD(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _23.xy, 0.0).xy;
                    vec4 _183 = vec4(_23.x, _23.y, _23.z, _182.w);
                    _183.w = dot(_180, vec2(0.5));
                    _179 = _180;
                    _182 = _183;
                    continue;
                }
                else
                {
                    break;
                }
            }
            vec4 _201 = vec4(_182.z, _142.y, _182.w, _142.w);
            _201.x = _184 + float(_179.y > 0.89999997615814208984375);
            _203 = _179;
            _204 = _201;
        }
        else
        {
            _203 = _143;
            _204 = vec4(vec2(0.0).x, _142.y, vec2(0.0).y, _142.w);
        }
        vec4 _207 = vec4(in_var_TEXCOORD0, -1.0, 1.0);
        vec3 _212 = vec3(MLAAConstants.g_xRTMetrics.xy, 1.0);
        vec2 _214;
        vec4 _217;
        _214 = _203;
        _217 = _207;
        float _219;
        for (;;)
        {
            _219 = _217.z;
            if ((_219 < 7.0) && (_217.w > 0.89999997615814208984375))
            {
                vec3 _24 = fma(_212, vec3(1.0, -1.0, 1.0), _217.xyz);
                vec2 _215 = TEXTURE_LOD(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _24.xy, 0.0).xy;
                vec4 _218 = vec4(_24.x, _24.y, _24.z, _217.w);
                _218.w = dot(_215, vec2(0.5));
                _214 = _215;
                _217 = _218;
                continue;
            }
            else
            {
                break;
            }
        }
        vec2 _280;
        if ((_204.x + _219) > 2.0)
        {
            vec4 _19 = fma(vec4(0.25 - _204.x, _204.x, _219, (-0.25) - _219), MLAAConstants.g_xRTMetrics.xyxy, in_var_TEXCOORD0.xyxy);
            vec4 _244 = TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _19.xy, 0.0, ivec2(-1, 0));
            vec4 _247 = TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _19.zw, 0.0, ivec2(1, 0));
            vec4 _248 = vec4(_244.x, _244.y, _247.x, _247.y);
            vec2 _249 = _248.xz;
            vec2 _253 = _249 * abs((_249 * 5.0) - vec2(3.75));
            vec4 _255 = round(vec4(_253.x, _248.y, _253.y, _248.w));
            vec2 _20 = fma(vec2(2.0), _255.yw, _255.xz);
            bvec2 _260 = notEqual(step(vec2(0.89999997615814208984375), vec4(_204.x, _217.z, _204.z, _217.w).zw), vec2(0.0));
            vec2 _265;
            if (_260.x)
            {
                vec2 _264 = _20;
                _264.x = 0.0;
                _265 = _264;
            }
            else
            {
                _265 = _20;
            }
            vec2 _270;
            if (_260.y)
            {
                vec2 _269 = _265;
                _269.y = 0.0;
                _270 = _269;
            }
            else
            {
                _270 = _265;
            }
            vec2 _26 = fma(vec2(0.0062500000931322574615478515625, 0.001785714295692741870880126953125), fma(vec2(20.0), _270, vec4(_204.x, _217.z, _204.z, _217.w).xy), vec2(0.00312500004656612873077392578125, 0.0008928571478463709354400634765625));
            vec2 _274 = _26;
            _274.x = _26.x + 0.5;
            vec2 _276 = _274;
            _276.y = _26.y;
            _280 = TEXTURE_LOD(SAMPLER_2D(g_xAreaTexture, g_xBilinearClamp), _276, 0.0).xy;
        }
        else
        {
            _280 = vec2(0.0);
        }
        vec4 _285 = _207;
        _285.x = in_var_TEXCOORD0.x + (0.25 * MLAAConstants.g_xRTMetrics.x);
        vec2 _287;
        vec4 _290;
        _287 = _214;
        _290 = _285;
        for (; (_290.z < 7.0) && (_290.w > 0.89999997615814208984375); )
        {
            vec3 _27 = fma(_212, vec3(-1.0, -1.0, 1.0), _290.xyz);
            vec4 _302 = TEXTURE_LOD(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _27.xy, 0.0);
            float _304 = _302.x;
            vec2 _309 = _302.xy;
            _309.x = _304 * abs((5.0 * _304) - 3.75);
            vec2 _288 = round(_309);
            vec4 _291 = vec4(_27.x, _27.y, _27.z, _290.w);
            _291.w = dot(_288, vec2(0.5));
            _287 = _288;
            _290 = _291;
            continue;
        }
        vec4 _350;
        if (TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), in_var_TEXCOORD0, 0.0, ivec2(1, 0)).x > 0.0)
        {
            vec2 _319;
            vec4 _322;
            _319 = _287;
            _322 = _285;
            float _324;
            for (;;)
            {
                _324 = _322.z;
                if ((_324 < 7.0) && (_322.w > 0.89999997615814208984375))
                {
                    vec3 _28 = fma(_212, vec3(1.0), _322.xyz);
                    vec4 _334 = TEXTURE_LOD(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _28.xy, 0.0);
                    float _336 = _334.x;
                    vec2 _341 = _334.xy;
                    _341.x = _336 * abs((5.0 * _336) - 3.75);
                    vec2 _320 = round(_341);
                    vec4 _323 = vec4(_28.x, _28.y, _28.z, _322.w);
                    _323.w = dot(_320, vec2(0.5));
                    _319 = _320;
                    _322 = _323;
                    continue;
                }
                else
                {
                    break;
                }
            }
            vec4 _348 = vec4(_290.z, _322.z, _290.w, _322.w);
            _348.y = _324 + float(_319.y > 0.89999997615814208984375);
            _350 = _348;
        }
        else
        {
            _350 = vec4(_290.z, vec2(0.0).x, _290.w, vec2(0.0).y);
        }
        vec2 _399;
        if ((_350.x + _350.y) > 2.0)
        {
            float _357 = -_350.x;
            vec4 _21 = fma(vec4(_357, _357, _350.yy), MLAAConstants.g_xRTMetrics.xyxy, in_var_TEXCOORD0.xyxy);
            vec2 _361 = _21.xy;
            vec4 _365 = _144;
            _365.x = TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _361, 0.0, ivec2(-1, 0)).y;
            vec4 _369 = _365;
            _369.y = TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _361, 0.0, ivec2(0, -1)).x;
            vec4 _372 = TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _21.zw, 0.0, ivec2(1, 0));
            vec4 _373 = vec4(_369.x, _369.y, _372.y, _372.x);
            vec2 _22 = fma(vec2(2.0), _373.xz, _373.yw);
            bvec2 _378 = notEqual(step(vec2(0.89999997615814208984375), _350.zw), vec2(0.0));
            vec2 _383;
            if (_378.x)
            {
                vec2 _382 = _22;
                _382.x = 0.0;
                _383 = _382;
            }
            else
            {
                _383 = _22;
            }
            vec2 _388;
            if (_378.y)
            {
                vec2 _387 = _383;
                _387.y = 0.0;
                _388 = _387;
            }
            else
            {
                _388 = _383;
            }
            vec2 _30 = fma(vec2(0.0062500000931322574615478515625, 0.001785714295692741870880126953125), fma(vec2(20.0), _388, _350.xy), vec2(0.00312500004656612873077392578125, 0.0008928571478463709354400634765625));
            vec2 _392 = _30;
            _392.x = _30.x + 0.5;
            vec2 _394 = _392;
            _394.y = _30.y;
            _399 = _280 + TEXTURE_LOD(SAMPLER_2D(g_xAreaTexture, g_xBilinearClamp), _394, 0.0).yx;
        }
        else
        {
            _399 = _280;
        }
        vec4 _520;
        vec2 _521;
        if (_399.x == (-_399.y))
        {
            vec2 _411;
            vec2 _414;
            _411 = vec2(0.0, 1.0);
            _414 = in_var_TEXCOORD2[0].xy;
            float _415;
            for (;;)
            {
                _415 = _414.x;
                if (((_415 > in_var_TEXCOORD2[2].x) && (_411.y > 0.828100025653839111328125)) && (_411.x == 0.0))
                {
                    _411 = TEXTURE_LOD(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _414, 0.0).xy;
                    _414 = fma(vec2(-2.0, -0.0), MLAAConstants.g_xRTMetrics.xy, _414);
                    continue;
                }
                else
                {
                    break;
                }
            }
            float _33 = fma(MLAAConstants.g_xRTMetrics.x, fma(-2.007874011993408203125, TEXTURE_LOD(SAMPLER_2D(g_xSearchTexture, g_xBilinearClamp), fma(vec2(0.5, -2.0), _411, vec2(0.0078125, 2.03125)), 0.0).x, 3.25), _415);
            vec3 _430 = _145;
            _430.x = _33;
            vec3 _432 = _430;
            _432.y = in_var_TEXCOORD2[1].y;
            vec2 _433 = _143;
            _433.x = _33;
            vec2 _441;
            vec2 _444;
            _441 = vec2(0.0, 1.0);
            _444 = in_var_TEXCOORD2[0].zw;
            float _445;
            for (;;)
            {
                _445 = _444.x;
                if (((_445 < in_var_TEXCOORD2[2].y) && (_441.y > 0.828100025653839111328125)) && (_441.x == 0.0))
                {
                    _441 = TEXTURE_LOD(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _444, 0.0).xy;
                    _444 = fma(vec2(2.0, 0.0), MLAAConstants.g_xRTMetrics.xy, _444);
                    continue;
                }
                else
                {
                    break;
                }
            }
            float _37 = fma(-MLAAConstants.g_xRTMetrics.x, fma(-2.007874011993408203125, TEXTURE_LOD(SAMPLER_2D(g_xSearchTexture, g_xBilinearClamp), fma(vec2(0.5, -2.0), _441, vec2(0.5234375, 2.03125)), 0.0).x, 3.25), _445);
            vec3 _461 = _432;
            _461.z = _37;
            vec2 _462 = _433;
            _462.y = _37;
            vec2 _467 = abs(round(fma(MLAAConstants.g_xRTMetrics.zz, _462, -in_var_TEXCOORD1.xx)));
            vec2 _40 = fma(vec2(0.0062500000931322574615478515625, 0.001785714295692741870880126953125), fma(vec2(16.0), round(vec2(TEXTURE_LOD(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _432.xy, 0.0).x, TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _461.zy, 0.0, ivec2(1, 0)).x) * 4.0), sqrt(_467)), vec2(0.00312500004656612873077392578125, 0.0008928571478463709354400634765625));
            vec2 _477 = _40;
            _477.y = fma(0.14285714924335479736328125, 0.0, _40.y);
            vec3 _480 = _461;
            _480.y = in_var_TEXCOORD0.y;
            vec2 _483 = step(_467, _467.yx);
            vec2 _489 = (_483 * 0.75) / vec2(_483.x + _483.y);
            float _490 = _489.x;
            float _497 = _489.y;
            vec2 _504 = _146;
            _504.x = (1.0 - (_490 * TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _480.xy, 0.0, ivec2(0, 1)).x)) - (_497 * TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _480.zy, 0.0, ivec2(1)).x);
            vec2 _515 = _504;
            _515.y = (1.0 - (_490 * TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _480.xy, 0.0, ivec2(0, -2)).x)) - (_497 * TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _480.zy, 0.0, ivec2(1, -2)).x);
            vec2 _517 = TEXTURE_LOD(SAMPLER_2D(g_xAreaTexture, g_xBilinearClamp), _477, 0.0).xy * clamp(_515, vec2(0.0), vec2(1.0));
            _520 = vec4(_517.x, _517.y, vec4(0.0).z, vec4(0.0).w);
            _521 = _160;
        }
        else
        {
            vec2 _519 = _146;
            _519.x = 0.0;
            _520 = vec4(_399.x, _399.y, vec4(0.0).z, vec4(0.0).w);
            _521 = _519;
        }
        _522 = _520;
        _523 = _521;
    }
    else
    {
        _522 = vec4(0.0);
        _523 = _160;
    }
    vec4 _649;
    if (_523.x > 0.0)
    {
        vec2 _531;
        vec2 _534;
        _531 = vec2(1.0, 0.0);
        _534 = in_var_TEXCOORD2[1].xy;
        float _535;
        for (;;)
        {
            _535 = _534.y;
            if (((_535 > in_var_TEXCOORD2[2].z) && (_531.x > 0.828100025653839111328125)) && (_531.y == 0.0))
            {
                _531 = TEXTURE_LOD(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _534, 0.0).xy;
                _534 = fma(vec2(-0.0, -2.0), MLAAConstants.g_xRTMetrics.xy, _534);
                continue;
            }
            else
            {
                break;
            }
        }
        float _44 = fma(MLAAConstants.g_xRTMetrics.y, fma(-2.007874011993408203125, TEXTURE_LOD(SAMPLER_2D(g_xSearchTexture, g_xBilinearClamp), fma(vec2(0.5, -2.0), _531.yx, vec2(0.0078125, 2.03125)), 0.0).x, 3.25), _535);
        vec3 _556 = _145;
        _556.y = _44;
        vec3 _558 = _556;
        _558.x = in_var_TEXCOORD2[0].x;
        vec2 _559 = _143;
        _559.x = _44;
        vec2 _567;
        vec2 _570;
        _567 = vec2(1.0, 0.0);
        _570 = in_var_TEXCOORD2[1].zw;
        float _571;
        for (;;)
        {
            _571 = _570.y;
            if (((_571 < in_var_TEXCOORD2[2].w) && (_567.x > 0.828100025653839111328125)) && (_567.y == 0.0))
            {
                _567 = TEXTURE_LOD(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _570, 0.0).xy;
                _570 = fma(vec2(0.0, 2.0), MLAAConstants.g_xRTMetrics.xy, _570);
                continue;
            }
            else
            {
                break;
            }
        }
        float _48 = fma(-MLAAConstants.g_xRTMetrics.y, fma(-2.007874011993408203125, TEXTURE_LOD(SAMPLER_2D(g_xSearchTexture, g_xBilinearClamp), fma(vec2(0.5, -2.0), _567.yx, vec2(0.5234375, 2.03125)), 0.0).x, 3.25), _571);
        vec3 _589 = _558;
        _589.z = _48;
        vec2 _590 = _559;
        _590.y = _48;
        vec2 _596 = abs(round(fma(MLAAConstants.g_xRTMetrics.ww, _590, -in_var_TEXCOORD1.yy)));
        vec2 _51 = fma(vec2(0.0062500000931322574615478515625, 0.001785714295692741870880126953125), fma(vec2(16.0), round(vec2(TEXTURE_LOD(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _558.xy, 0.0).y, TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _589.xz, 0.0, ivec2(0, 1)).y) * 4.0), sqrt(_596)), vec2(0.00312500004656612873077392578125, 0.0008928571478463709354400634765625));
        vec2 _606 = _51;
        _606.y = fma(0.14285714924335479736328125, 0.0, _51.y);
        vec3 _610 = _589;
        _610.x = in_var_TEXCOORD0.x;
        vec2 _613 = step(_596, _596.yx);
        vec2 _619 = (_613 * 0.75) / vec2(_613.x + _613.y);
        float _620 = _619.x;
        float _627 = _619.y;
        vec2 _634 = _146;
        _634.x = (1.0 - (_620 * TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _610.xy, 0.0, ivec2(1, 0)).y)) - (_627 * TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _610.xz, 0.0, ivec2(1)).y);
        vec2 _645 = _634;
        _645.y = (1.0 - (_620 * TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _610.xy, 0.0, ivec2(-2, 0)).y)) - (_627 * TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xEdgesTexture, g_xBilinearClamp), _610.xz, 0.0, ivec2(-2, 1)).y);
        vec2 _647 = TEXTURE_LOD(SAMPLER_2D(g_xAreaTexture, g_xBilinearClamp), _606, 0.0).xy * clamp(_645, vec2(0.0), vec2(1.0));
        _649 = vec4(_522.x, _522.y, _647.x, _647.y);
    }
    else
    {
        _649 = _522;
    }
    out_var_SV_Target = _649;
}

