
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    float g_fBiasFactor;
    float g_fNearClip;
    float g_fFarClip;
};

layout(set = 2, binding = 7, std140) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 3, binding = 11, std140) uniform type_MeshConstants
{
    vec3 g_xPrecisionOffset;
    uint g_bIsBillboard;
    vec3 g_xPrecisionScale;
    uint g_bIsInteractive;
} MeshConstants;

layout(location = 0) in vec4 in_var_POSITION0;
layout(location = 1) in vec4 in_var_TEXCOORD0;
layout(location = 2) in vec3 in_var_NORMAL;
layout(location = 3) in vec3 in_var_TESSNORMAL;
layout(location = 4) in vec4 in_var_POSITION1;
layout(location = 5) in vec4 in_var_POSITION2;
layout(location = 6) in vec4 in_var_POSITION3;
layout(location = 7) in vec4 in_var_POSITION4;

vec4 _41;

void main()
{
    vec3 _57 = (in_var_POSITION0.xyz * MeshConstants.g_xPrecisionScale) + MeshConstants.g_xPrecisionOffset;
    vec4 _59 = _41;
    _59.x = dot(_57, in_var_POSITION2.xyz);
    vec4 _61 = _59;
    _61.y = dot(_57, in_var_POSITION3.xyz);
    vec4 _63 = _61;
    _63.z = dot(_57, in_var_POSITION4.xyz);
    vec4 _90;
    if (MeshConstants.g_bIsInteractive != 0u)
    {
        vec4 _72 = _41;
        _72.x = in_var_POSITION2.w;
        vec4 _74 = _72;
        _74.y = in_var_POSITION3.w;
        vec4 _76 = _74;
        _76.z = in_var_POSITION4.w;
        vec3 _82 = cross(_76.xyz, _63.xyz);
        vec3 _88 = (((_82 * sqrt(clamp(1.0 - dot(_76.xyz, _76.xyz), 0.0, 1.0))) + cross(_76.xyz, _82)) * (2.0 * in_var_POSITION0.w)) + _63.xyz;
        _90 = vec4(_88.x, _88.y, _88.z, _63.w);
    }
    else
    {
        _90 = _63;
    }
    gl_Position = vec4(_90.xyz + in_var_POSITION1.xyz, 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
}

