
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    uvec3 g_xPad;
};

layout(set = 3, binding = 9, std140) uniform type_UnpackConstants
{
    vec4 g_xScalingFactors;
    vec4 g_xOffsets;
} UnpackConstants;

layout(set = 3, binding = 10, std140) uniform type_InstancedConstants
{
    uint g_uInstancedAnimID;
} InstancedConstants;

layout(set = 2, binding = 7, scalar) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 3, binding = 80, std430) readonly buffer type_StructuredBuffer_v4float
{
    vec4 _m0[];
} g_xInstanceTexture;

layout(location = 0) in vec4 in_var_POSITION;
layout(location = 1) in vec3 in_var_TANGENT;
layout(location = 2) in vec3 in_var_BINORMAL;
layout(location = 3) in vec3 in_var_NORMAL;
layout(location = 4) in vec3 in_var_TESSNORMAL;
layout(location = 5) in vec4 in_var_TEXCOORD;
layout(location = 6) in vec4 in_var_BLENDWEIGHTS0;
layout(location = 7) in vec4 in_var_BLENDWEIGHTS1;
layout(location = 8) in uvec4 in_var_BLENDINDICES0;
layout(location = 9) in uvec4 in_var_BLENDINDICES1;

void main()
{
    uvec4 _70 = in_var_BLENDINDICES0;
    uvec4 _71 = in_var_BLENDINDICES1;
    vec4 _72 = in_var_BLENDWEIGHTS0;
    vec4 _73 = in_var_BLENDWEIGHTS1;
    uint _94 = InstancedConstants.g_uInstancedAnimID + (_70.x * 3u);
    mat3x4 _69 = mat3x4(g_xInstanceTexture._m0[_94 + 8u], g_xInstanceTexture._m0[_94 + 9u], g_xInstanceTexture._m0[_94 + 10u]);
    _69[2].z = (_69[0u].x * _69[1u].y) - (_69[0u].y * _69[1u].x);
    mat3x4 _122;
    _122 = _69 * _72.x;
    mat3x4 _123;
    for (int _125 = 1; _125 < 4; _122 = _123, _125++)
    {
        uint _130 = uint(_125);
        if (_72[_130] == 0.0)
        {
            break;
        }
        uint _139 = InstancedConstants.g_uInstancedAnimID + (_70[_130] * 3u);
        mat3x4 _68 = mat3x4(g_xInstanceTexture._m0[_139 + 8u], g_xInstanceTexture._m0[_139 + 9u], g_xInstanceTexture._m0[_139 + 10u]);
        _68[2].z = (_68[0u].x * _68[1u].y) - (_68[0u].y * _68[1u].x);
        mat3x4 _163 = _68 * _72[_130];
        _123 = mat3x4(_122[0] + _163[0], _122[1] + _163[1], _122[2] + _163[2]);
    }
    mat3x4 _174;
    _174 = _122;
    mat3x4 _175;
    for (int _177 = 0; _177 < 4; _174 = _175, _177++)
    {
        uint _182 = uint(_177);
        if (_73[_182] == 0.0)
        {
            break;
        }
        uint _191 = InstancedConstants.g_uInstancedAnimID + (_71[_182] * 3u);
        mat3x4 _67 = mat3x4(g_xInstanceTexture._m0[_191 + 8u], g_xInstanceTexture._m0[_191 + 9u], g_xInstanceTexture._m0[_191 + 10u]);
        _67[2].z = (_67[0u].x * _67[1u].y) - (_67[0u].y * _67[1u].x);
        mat3x4 _215 = _67 * _73[_182];
        _175 = mat3x4(_174[0] + _215[0], _174[1] + _215[1], _174[2] + _215[2]);
    }
    gl_Position = vec4(vec4(vec4((in_var_POSITION.xyz * UnpackConstants.g_xScalingFactors.xyz) + UnpackConstants.g_xOffsets.xyz, 1.0) * _174, 1.0) * mat3x4(g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 5u], g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 6u], g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 7u]), 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
}

