#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 9, std140) uniform type_FXAAConstants
{
    vec2 g_xRcpFrame;
} FXAAConstants;

layout(set = 0, binding = 3) uniform sampler g_xBilinearClamp;
layout(set = 1, binding = 50) uniform TEXTURE_2D g_xPostToneMapFrameBufferTexture;

layout(location = 0) in vec2 in_var_TEXCOORD0;
layout(location = 0) out vec4 out_var_SV_Target;

vec2 _51;
vec4 _52;
vec2 _53;

void main()
{
    vec4 _901;
    do
    {
        vec2 _63 = _51;
        _63.x = in_var_TEXCOORD0.x;
        vec2 _65 = _63;
        _65.y = in_var_TEXCOORD0.y;
        vec4 _67 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _65, 0.0);
        vec4 _69 = TEXTURE_GATHER(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _65, 3);
        vec4 _71 = TEXTURE_GATHER_OFFSET(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _65, ivec2(-1), 3);
        float _72 = _69.x;
        float _73 = _67.w;
        float _76 = _69.z;
        float _79 = _71.z;
        float _80 = _71.x;
        float _83 = max(max(_79, _80), max(_76, max(_72, _73)));
        float _86 = _83 - min(min(_79, _80), min(_76, min(_72, _73)));
        if (_86 < max(0.083333335816860198974609375, _83 * 0.16666667163372039794921875))
        {
            _901 = _67;
            break;
        }
        vec4 _92 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _65, 0.0, ivec2(1, -1));
        float _93 = _92.w;
        vec4 _95 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _65, 0.0, ivec2(-1, 1));
        float _96 = _95.w;
        float _97 = _79 + _72;
        float _98 = _80 + _76;
        float _101 = (-2.0) * _73;
        float _104 = _69.y;
        float _105 = _93 + _104;
        float _106 = _71.w;
        float _112 = _106 + _96;
        bool _132 = (abs(((-2.0) * _80) + _112) + ((abs(_101 + _97) * 2.0) + abs(((-2.0) * _76) + _105))) >= (abs(((-2.0) * _72) + (_96 + _104)) + ((abs(_101 + _98) * 2.0) + abs(((-2.0) * _79) + (_106 + _93))));
        bool _135 = !_132;
        vec4 _139;
        if (_135)
        {
            vec4 _138 = _52;
            _138.z = _80;
            _139 = _138;
        }
        else
        {
            _139 = _71;
        }
        vec4 _143;
        if (_135)
        {
            vec4 _142 = _52;
            _142.x = _76;
            _143 = _142;
        }
        else
        {
            _143 = _69;
        }
        float _147;
        if (_132)
        {
            _147 = FXAAConstants.g_xRcpFrame.y;
        }
        else
        {
            _147 = FXAAConstants.g_xRcpFrame.x;
        }
        float _156 = abs(_139.z - _73);
        float _157 = abs(_143.x - _73);
        bool _158 = _156 >= _157;
        float _163;
        if (_158)
        {
            _163 = -_147;
        }
        else
        {
            _163 = _147;
        }
        float _166 = clamp(abs(((((_97 + _98) * 2.0) + (_112 + _105)) * 0.083333335816860198974609375) - _73) * (1.0 / _86), 0.0, 1.0);
        float _167 = _135 ? 0.0 : FXAAConstants.g_xRcpFrame.x;
        float _169 = _132 ? 0.0 : FXAAConstants.g_xRcpFrame.y;
        vec2 _175;
        if (_135)
        {
            vec2 _174 = _65;
            _174.x = in_var_TEXCOORD0.x + (_163 * 0.5);
            _175 = _174;
        }
        else
        {
            _175 = _65;
        }
        vec2 _182;
        if (_132)
        {
            vec2 _181 = _175;
            _181.y = _175.y + (_163 * 0.5);
            _182 = _181;
        }
        else
        {
            _182 = _175;
        }
        float _184 = _182.x - _167;
        vec2 _185 = _51;
        _185.x = _184;
        vec2 _188 = _185;
        _188.y = _182.y - _169;
        float _189 = _182.x + _167;
        vec2 _190 = _51;
        _190.x = _189;
        vec2 _192 = _190;
        _192.y = _182.y + _169;
        float _204 = max(_156, _157) * 0.25;
        float _205 = ((!_158) ? (_143.x + _73) : (_139.z + _73)) * 0.5;
        float _207 = (((-2.0) * _166) + 3.0) * (_166 * _166);
        bool _208 = (_73 - _205) < 0.0;
        float _209 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _188, 0.0).w - _205;
        float _210 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _192, 0.0).w - _205;
        bool _215 = !(abs(_209) >= _204);
        vec2 _221;
        if (_215)
        {
            vec2 _220 = _188;
            _220.x = _184 - (_167 * 1.5);
            _221 = _220;
        }
        else
        {
            _221 = _188;
        }
        vec2 _228;
        if (_215)
        {
            vec2 _227 = _221;
            _227.y = _221.y - (_169 * 1.5);
            _228 = _227;
        }
        else
        {
            _228 = _221;
        }
        bool _229 = !(abs(_210) >= _204);
        vec2 _236;
        if (_229)
        {
            vec2 _235 = _192;
            _235.x = _189 + (_167 * 1.5);
            _236 = _235;
        }
        else
        {
            _236 = _192;
        }
        vec2 _243;
        if (_229)
        {
            vec2 _242 = _236;
            _242.y = _236.y + (_169 * 1.5);
            _243 = _242;
        }
        else
        {
            _243 = _236;
        }
        vec2 _849;
        vec2 _850;
        float _851;
        float _852;
        if (_215 || _229)
        {
            float _251;
            if (_215)
            {
                _251 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _228, 0.0).w;
            }
            else
            {
                _251 = _209;
            }
            float _257;
            if (_229)
            {
                _257 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _243, 0.0).w;
            }
            else
            {
                _257 = _210;
            }
            float _261;
            if (_215)
            {
                _261 = _251 - _205;
            }
            else
            {
                _261 = _251;
            }
            float _265;
            if (_229)
            {
                _265 = _257 - _205;
            }
            else
            {
                _265 = _257;
            }
            bool _270 = !(abs(_261) >= _204);
            vec2 _277;
            if (_270)
            {
                vec2 _276 = _228;
                _276.x = _228.x - (_167 * 2.0);
                _277 = _276;
            }
            else
            {
                _277 = _228;
            }
            vec2 _284;
            if (_270)
            {
                vec2 _283 = _277;
                _283.y = _277.y - (_169 * 2.0);
                _284 = _283;
            }
            else
            {
                _284 = _277;
            }
            bool _285 = !(abs(_265) >= _204);
            vec2 _293;
            if (_285)
            {
                vec2 _292 = _243;
                _292.x = _243.x + (_167 * 2.0);
                _293 = _292;
            }
            else
            {
                _293 = _243;
            }
            vec2 _300;
            if (_285)
            {
                vec2 _299 = _293;
                _299.y = _293.y + (_169 * 2.0);
                _300 = _299;
            }
            else
            {
                _300 = _293;
            }
            vec2 _845;
            vec2 _846;
            float _847;
            float _848;
            if (_270 || _285)
            {
                float _308;
                if (_270)
                {
                    _308 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _284, 0.0).w;
                }
                else
                {
                    _308 = _261;
                }
                float _314;
                if (_285)
                {
                    _314 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _300, 0.0).w;
                }
                else
                {
                    _314 = _265;
                }
                float _318;
                if (_270)
                {
                    _318 = _308 - _205;
                }
                else
                {
                    _318 = _308;
                }
                float _322;
                if (_285)
                {
                    _322 = _314 - _205;
                }
                else
                {
                    _322 = _314;
                }
                bool _327 = !(abs(_318) >= _204);
                vec2 _334;
                if (_327)
                {
                    vec2 _333 = _284;
                    _333.x = _284.x - (_167 * 2.0);
                    _334 = _333;
                }
                else
                {
                    _334 = _284;
                }
                vec2 _341;
                if (_327)
                {
                    vec2 _340 = _334;
                    _340.y = _334.y - (_169 * 2.0);
                    _341 = _340;
                }
                else
                {
                    _341 = _334;
                }
                bool _342 = !(abs(_322) >= _204);
                vec2 _350;
                if (_342)
                {
                    vec2 _349 = _300;
                    _349.x = _300.x + (_167 * 2.0);
                    _350 = _349;
                }
                else
                {
                    _350 = _300;
                }
                vec2 _357;
                if (_342)
                {
                    vec2 _356 = _350;
                    _356.y = _350.y + (_169 * 2.0);
                    _357 = _356;
                }
                else
                {
                    _357 = _350;
                }
                vec2 _841;
                vec2 _842;
                float _843;
                float _844;
                if (_327 || _342)
                {
                    float _365;
                    if (_327)
                    {
                        _365 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _341, 0.0).w;
                    }
                    else
                    {
                        _365 = _318;
                    }
                    float _371;
                    if (_342)
                    {
                        _371 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _357, 0.0).w;
                    }
                    else
                    {
                        _371 = _322;
                    }
                    float _375;
                    if (_327)
                    {
                        _375 = _365 - _205;
                    }
                    else
                    {
                        _375 = _365;
                    }
                    float _379;
                    if (_342)
                    {
                        _379 = _371 - _205;
                    }
                    else
                    {
                        _379 = _371;
                    }
                    bool _384 = !(abs(_375) >= _204);
                    vec2 _391;
                    if (_384)
                    {
                        vec2 _390 = _341;
                        _390.x = _341.x - (_167 * 2.0);
                        _391 = _390;
                    }
                    else
                    {
                        _391 = _341;
                    }
                    vec2 _398;
                    if (_384)
                    {
                        vec2 _397 = _391;
                        _397.y = _391.y - (_169 * 2.0);
                        _398 = _397;
                    }
                    else
                    {
                        _398 = _391;
                    }
                    bool _399 = !(abs(_379) >= _204);
                    vec2 _407;
                    if (_399)
                    {
                        vec2 _406 = _357;
                        _406.x = _357.x + (_167 * 2.0);
                        _407 = _406;
                    }
                    else
                    {
                        _407 = _357;
                    }
                    vec2 _414;
                    if (_399)
                    {
                        vec2 _413 = _407;
                        _413.y = _407.y + (_169 * 2.0);
                        _414 = _413;
                    }
                    else
                    {
                        _414 = _407;
                    }
                    vec2 _837;
                    vec2 _838;
                    float _839;
                    float _840;
                    if (_384 || _399)
                    {
                        float _422;
                        if (_384)
                        {
                            _422 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _398, 0.0).w;
                        }
                        else
                        {
                            _422 = _375;
                        }
                        float _428;
                        if (_399)
                        {
                            _428 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _414, 0.0).w;
                        }
                        else
                        {
                            _428 = _379;
                        }
                        float _432;
                        if (_384)
                        {
                            _432 = _422 - _205;
                        }
                        else
                        {
                            _432 = _422;
                        }
                        float _436;
                        if (_399)
                        {
                            _436 = _428 - _205;
                        }
                        else
                        {
                            _436 = _428;
                        }
                        bool _441 = !(abs(_432) >= _204);
                        vec2 _448;
                        if (_441)
                        {
                            vec2 _447 = _398;
                            _447.x = _398.x - (_167 * 2.0);
                            _448 = _447;
                        }
                        else
                        {
                            _448 = _398;
                        }
                        vec2 _455;
                        if (_441)
                        {
                            vec2 _454 = _448;
                            _454.y = _448.y - (_169 * 2.0);
                            _455 = _454;
                        }
                        else
                        {
                            _455 = _448;
                        }
                        bool _456 = !(abs(_436) >= _204);
                        vec2 _464;
                        if (_456)
                        {
                            vec2 _463 = _414;
                            _463.x = _414.x + (_167 * 2.0);
                            _464 = _463;
                        }
                        else
                        {
                            _464 = _414;
                        }
                        vec2 _471;
                        if (_456)
                        {
                            vec2 _470 = _464;
                            _470.y = _464.y + (_169 * 2.0);
                            _471 = _470;
                        }
                        else
                        {
                            _471 = _464;
                        }
                        vec2 _833;
                        vec2 _834;
                        float _835;
                        float _836;
                        if (_441 || _456)
                        {
                            float _479;
                            if (_441)
                            {
                                _479 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _455, 0.0).w;
                            }
                            else
                            {
                                _479 = _432;
                            }
                            float _485;
                            if (_456)
                            {
                                _485 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _471, 0.0).w;
                            }
                            else
                            {
                                _485 = _436;
                            }
                            float _489;
                            if (_441)
                            {
                                _489 = _479 - _205;
                            }
                            else
                            {
                                _489 = _479;
                            }
                            float _493;
                            if (_456)
                            {
                                _493 = _485 - _205;
                            }
                            else
                            {
                                _493 = _485;
                            }
                            bool _498 = !(abs(_489) >= _204);
                            vec2 _505;
                            if (_498)
                            {
                                vec2 _504 = _455;
                                _504.x = _455.x - (_167 * 2.0);
                                _505 = _504;
                            }
                            else
                            {
                                _505 = _455;
                            }
                            vec2 _512;
                            if (_498)
                            {
                                vec2 _511 = _505;
                                _511.y = _505.y - (_169 * 2.0);
                                _512 = _511;
                            }
                            else
                            {
                                _512 = _505;
                            }
                            bool _513 = !(abs(_493) >= _204);
                            vec2 _521;
                            if (_513)
                            {
                                vec2 _520 = _471;
                                _520.x = _471.x + (_167 * 2.0);
                                _521 = _520;
                            }
                            else
                            {
                                _521 = _471;
                            }
                            vec2 _528;
                            if (_513)
                            {
                                vec2 _527 = _521;
                                _527.y = _521.y + (_169 * 2.0);
                                _528 = _527;
                            }
                            else
                            {
                                _528 = _521;
                            }
                            vec2 _829;
                            vec2 _830;
                            float _831;
                            float _832;
                            if (_498 || _513)
                            {
                                float _536;
                                if (_498)
                                {
                                    _536 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _512, 0.0).w;
                                }
                                else
                                {
                                    _536 = _489;
                                }
                                float _542;
                                if (_513)
                                {
                                    _542 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _528, 0.0).w;
                                }
                                else
                                {
                                    _542 = _493;
                                }
                                float _546;
                                if (_498)
                                {
                                    _546 = _536 - _205;
                                }
                                else
                                {
                                    _546 = _536;
                                }
                                float _550;
                                if (_513)
                                {
                                    _550 = _542 - _205;
                                }
                                else
                                {
                                    _550 = _542;
                                }
                                bool _555 = !(abs(_546) >= _204);
                                vec2 _562;
                                if (_555)
                                {
                                    vec2 _561 = _512;
                                    _561.x = _512.x - (_167 * 2.0);
                                    _562 = _561;
                                }
                                else
                                {
                                    _562 = _512;
                                }
                                vec2 _569;
                                if (_555)
                                {
                                    vec2 _568 = _562;
                                    _568.y = _562.y - (_169 * 2.0);
                                    _569 = _568;
                                }
                                else
                                {
                                    _569 = _562;
                                }
                                bool _570 = !(abs(_550) >= _204);
                                vec2 _578;
                                if (_570)
                                {
                                    vec2 _577 = _528;
                                    _577.x = _528.x + (_167 * 2.0);
                                    _578 = _577;
                                }
                                else
                                {
                                    _578 = _528;
                                }
                                vec2 _585;
                                if (_570)
                                {
                                    vec2 _584 = _578;
                                    _584.y = _578.y + (_169 * 2.0);
                                    _585 = _584;
                                }
                                else
                                {
                                    _585 = _578;
                                }
                                vec2 _825;
                                vec2 _826;
                                float _827;
                                float _828;
                                if (_555 || _570)
                                {
                                    float _593;
                                    if (_555)
                                    {
                                        _593 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _569, 0.0).w;
                                    }
                                    else
                                    {
                                        _593 = _546;
                                    }
                                    float _599;
                                    if (_570)
                                    {
                                        _599 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _585, 0.0).w;
                                    }
                                    else
                                    {
                                        _599 = _550;
                                    }
                                    float _603;
                                    if (_555)
                                    {
                                        _603 = _593 - _205;
                                    }
                                    else
                                    {
                                        _603 = _593;
                                    }
                                    float _607;
                                    if (_570)
                                    {
                                        _607 = _599 - _205;
                                    }
                                    else
                                    {
                                        _607 = _599;
                                    }
                                    bool _612 = !(abs(_603) >= _204);
                                    vec2 _619;
                                    if (_612)
                                    {
                                        vec2 _618 = _569;
                                        _618.x = _569.x - (_167 * 2.0);
                                        _619 = _618;
                                    }
                                    else
                                    {
                                        _619 = _569;
                                    }
                                    vec2 _626;
                                    if (_612)
                                    {
                                        vec2 _625 = _619;
                                        _625.y = _619.y - (_169 * 2.0);
                                        _626 = _625;
                                    }
                                    else
                                    {
                                        _626 = _619;
                                    }
                                    bool _627 = !(abs(_607) >= _204);
                                    vec2 _635;
                                    if (_627)
                                    {
                                        vec2 _634 = _585;
                                        _634.x = _585.x + (_167 * 2.0);
                                        _635 = _634;
                                    }
                                    else
                                    {
                                        _635 = _585;
                                    }
                                    vec2 _642;
                                    if (_627)
                                    {
                                        vec2 _641 = _635;
                                        _641.y = _635.y + (_169 * 2.0);
                                        _642 = _641;
                                    }
                                    else
                                    {
                                        _642 = _635;
                                    }
                                    vec2 _821;
                                    vec2 _822;
                                    float _823;
                                    float _824;
                                    if (_612 || _627)
                                    {
                                        float _650;
                                        if (_612)
                                        {
                                            _650 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _626, 0.0).w;
                                        }
                                        else
                                        {
                                            _650 = _603;
                                        }
                                        float _656;
                                        if (_627)
                                        {
                                            _656 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _642, 0.0).w;
                                        }
                                        else
                                        {
                                            _656 = _607;
                                        }
                                        float _660;
                                        if (_612)
                                        {
                                            _660 = _650 - _205;
                                        }
                                        else
                                        {
                                            _660 = _650;
                                        }
                                        float _664;
                                        if (_627)
                                        {
                                            _664 = _656 - _205;
                                        }
                                        else
                                        {
                                            _664 = _656;
                                        }
                                        bool _669 = !(abs(_660) >= _204);
                                        vec2 _676;
                                        if (_669)
                                        {
                                            vec2 _675 = _626;
                                            _675.x = _626.x - (_167 * 2.0);
                                            _676 = _675;
                                        }
                                        else
                                        {
                                            _676 = _626;
                                        }
                                        vec2 _683;
                                        if (_669)
                                        {
                                            vec2 _682 = _676;
                                            _682.y = _676.y - (_169 * 2.0);
                                            _683 = _682;
                                        }
                                        else
                                        {
                                            _683 = _676;
                                        }
                                        bool _684 = !(abs(_664) >= _204);
                                        vec2 _692;
                                        if (_684)
                                        {
                                            vec2 _691 = _642;
                                            _691.x = _642.x + (_167 * 2.0);
                                            _692 = _691;
                                        }
                                        else
                                        {
                                            _692 = _642;
                                        }
                                        vec2 _699;
                                        if (_684)
                                        {
                                            vec2 _698 = _692;
                                            _698.y = _692.y + (_169 * 2.0);
                                            _699 = _698;
                                        }
                                        else
                                        {
                                            _699 = _692;
                                        }
                                        vec2 _817;
                                        vec2 _818;
                                        float _819;
                                        float _820;
                                        if (_669 || _684)
                                        {
                                            float _707;
                                            if (_669)
                                            {
                                                _707 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _683, 0.0).w;
                                            }
                                            else
                                            {
                                                _707 = _660;
                                            }
                                            float _713;
                                            if (_684)
                                            {
                                                _713 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _699, 0.0).w;
                                            }
                                            else
                                            {
                                                _713 = _664;
                                            }
                                            float _717;
                                            if (_669)
                                            {
                                                _717 = _707 - _205;
                                            }
                                            else
                                            {
                                                _717 = _707;
                                            }
                                            float _721;
                                            if (_684)
                                            {
                                                _721 = _713 - _205;
                                            }
                                            else
                                            {
                                                _721 = _713;
                                            }
                                            bool _726 = !(abs(_717) >= _204);
                                            vec2 _733;
                                            if (_726)
                                            {
                                                vec2 _732 = _683;
                                                _732.x = _683.x - (_167 * 4.0);
                                                _733 = _732;
                                            }
                                            else
                                            {
                                                _733 = _683;
                                            }
                                            vec2 _740;
                                            if (_726)
                                            {
                                                vec2 _739 = _733;
                                                _739.y = _733.y - (_169 * 4.0);
                                                _740 = _739;
                                            }
                                            else
                                            {
                                                _740 = _733;
                                            }
                                            bool _741 = !(abs(_721) >= _204);
                                            vec2 _749;
                                            if (_741)
                                            {
                                                vec2 _748 = _699;
                                                _748.x = _699.x + (_167 * 4.0);
                                                _749 = _748;
                                            }
                                            else
                                            {
                                                _749 = _699;
                                            }
                                            vec2 _756;
                                            if (_741)
                                            {
                                                vec2 _755 = _749;
                                                _755.y = _749.y + (_169 * 4.0);
                                                _756 = _755;
                                            }
                                            else
                                            {
                                                _756 = _749;
                                            }
                                            vec2 _813;
                                            vec2 _814;
                                            float _815;
                                            float _816;
                                            if (_726 || _741)
                                            {
                                                float _764;
                                                if (_726)
                                                {
                                                    _764 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _740, 0.0).w;
                                                }
                                                else
                                                {
                                                    _764 = _717;
                                                }
                                                float _770;
                                                if (_741)
                                                {
                                                    _770 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _756, 0.0).w;
                                                }
                                                else
                                                {
                                                    _770 = _721;
                                                }
                                                float _774;
                                                if (_726)
                                                {
                                                    _774 = _764 - _205;
                                                }
                                                else
                                                {
                                                    _774 = _764;
                                                }
                                                float _778;
                                                if (_741)
                                                {
                                                    _778 = _770 - _205;
                                                }
                                                else
                                                {
                                                    _778 = _770;
                                                }
                                                bool _783 = !(abs(_774) >= _204);
                                                vec2 _790;
                                                if (_783)
                                                {
                                                    vec2 _789 = _740;
                                                    _789.x = _740.x - (_167 * 8.0);
                                                    _790 = _789;
                                                }
                                                else
                                                {
                                                    _790 = _740;
                                                }
                                                vec2 _797;
                                                if (_783)
                                                {
                                                    vec2 _796 = _790;
                                                    _796.y = _790.y - (_169 * 8.0);
                                                    _797 = _796;
                                                }
                                                else
                                                {
                                                    _797 = _790;
                                                }
                                                bool _798 = !(abs(_778) >= _204);
                                                vec2 _805;
                                                if (_798)
                                                {
                                                    vec2 _804 = _756;
                                                    _804.x = _756.x + (_167 * 8.0);
                                                    _805 = _804;
                                                }
                                                else
                                                {
                                                    _805 = _756;
                                                }
                                                vec2 _812;
                                                if (_798)
                                                {
                                                    vec2 _811 = _805;
                                                    _811.y = _805.y + (_169 * 8.0);
                                                    _812 = _811;
                                                }
                                                else
                                                {
                                                    _812 = _805;
                                                }
                                                _813 = _812;
                                                _814 = _797;
                                                _815 = _778;
                                                _816 = _774;
                                            }
                                            else
                                            {
                                                _813 = _756;
                                                _814 = _740;
                                                _815 = _721;
                                                _816 = _717;
                                            }
                                            _817 = _813;
                                            _818 = _814;
                                            _819 = _815;
                                            _820 = _816;
                                        }
                                        else
                                        {
                                            _817 = _699;
                                            _818 = _683;
                                            _819 = _664;
                                            _820 = _660;
                                        }
                                        _821 = _817;
                                        _822 = _818;
                                        _823 = _819;
                                        _824 = _820;
                                    }
                                    else
                                    {
                                        _821 = _642;
                                        _822 = _626;
                                        _823 = _607;
                                        _824 = _603;
                                    }
                                    _825 = _821;
                                    _826 = _822;
                                    _827 = _823;
                                    _828 = _824;
                                }
                                else
                                {
                                    _825 = _585;
                                    _826 = _569;
                                    _827 = _550;
                                    _828 = _546;
                                }
                                _829 = _825;
                                _830 = _826;
                                _831 = _827;
                                _832 = _828;
                            }
                            else
                            {
                                _829 = _528;
                                _830 = _512;
                                _831 = _493;
                                _832 = _489;
                            }
                            _833 = _829;
                            _834 = _830;
                            _835 = _831;
                            _836 = _832;
                        }
                        else
                        {
                            _833 = _471;
                            _834 = _455;
                            _835 = _436;
                            _836 = _432;
                        }
                        _837 = _833;
                        _838 = _834;
                        _839 = _835;
                        _840 = _836;
                    }
                    else
                    {
                        _837 = _414;
                        _838 = _398;
                        _839 = _379;
                        _840 = _375;
                    }
                    _841 = _837;
                    _842 = _838;
                    _843 = _839;
                    _844 = _840;
                }
                else
                {
                    _841 = _357;
                    _842 = _341;
                    _843 = _322;
                    _844 = _318;
                }
                _845 = _841;
                _846 = _842;
                _847 = _843;
                _848 = _844;
            }
            else
            {
                _845 = _300;
                _846 = _284;
                _847 = _265;
                _848 = _261;
            }
            _849 = _845;
            _850 = _846;
            _851 = _847;
            _852 = _848;
        }
        else
        {
            _849 = _243;
            _850 = _228;
            _851 = _210;
            _852 = _209;
        }
        float _861;
        if (_135)
        {
            _861 = in_var_TEXCOORD0.y - _850.y;
        }
        else
        {
            _861 = in_var_TEXCOORD0.x - _850.x;
        }
        float _866;
        if (_135)
        {
            _866 = _849.y - in_var_TEXCOORD0.y;
        }
        else
        {
            _866 = _849.x - in_var_TEXCOORD0.x;
        }
        float _881 = max(((_861 < _866) ? ((_852 < 0.0) != _208) : ((_851 < 0.0) != _208)) ? ((min(_861, _866) * ((-1.0) / (_866 + _861))) + 0.5) : 0.0, (_207 * _207) * 0.75);
        vec2 _887;
        if (_135)
        {
            vec2 _886 = _65;
            _886.x = in_var_TEXCOORD0.x + (_881 * _163);
            _887 = _886;
        }
        else
        {
            _887 = _65;
        }
        vec2 _894;
        if (_132)
        {
            vec2 _893 = _887;
            _893.y = _887.y + (_881 * _163);
            _894 = _893;
        }
        else
        {
            _894 = _887;
        }
        _901 = vec4(TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _894, 0.0).xyz, _73);
        break;
    } while(false);
    out_var_SV_Target = _901;
}

