// Reload
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_scalar_block_layout : require


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 1, scalar) uniform type_QuadConstants
{
    uint g_bUseTexture;
    uint g_bUseRadialClip;
    float g_fClipStartRadius;
    float g_fClipEndRadius;
    float g_fInnerClipStartRadius;
    float g_fInnerClipEndRadius;
    vec2 g_xClipCentre;
    uint g_bUseWrapSampler;
    uint g_bUsePointMag;
    uint g_bUseDF;
    uint g_bUseTextureAlphaMask;
    vec2 g_xAlphaMaskOrigin;
    vec2 g_xOneOverAlphaMaskDimensions;
    vec4 g_xAlphaMaskUVs;
    vec4 g_xOutlineColour;
    vec4 g_xOuterGlowColour;
    vec2 g_fTextureSize;
    float g_fOuterGlowMin;
    float g_fOuterGlowMax;
    float g_fOutlineHalfThickness;
    float g_fOutlineOffset;
    float g_fAntiAliasDistance;
    float g_fInnerAlpha;
    float g_fTolerance;
    uint g_bOutline;
    uint g_bAntiAlias;
    uint g_bOuterGlow;
    vec2 g_xAlphaMaskRotation;
    uint g_bUseMSDF;
    int g_iBlendOperation;
    float g_fBlendLerp;
    vec2 g_xBlendUVOffset;
} QuadConstants;

layout(set = 0, binding = 3) uniform sampler g_xBilinearClamp;
layout(set = 0, binding = 4) uniform sampler g_xTrilinearWrap;
layout(set = 0, binding = 5) uniform sampler g_xTrilinearClamp;
layout(set = 0, binding = 10) uniform sampler g_xPointMagWrap;
layout(set = 0, binding = 11) uniform sampler g_xPointMagClamp;
layout(set = 1, binding = 48) uniform TEXTURE_2D g_xTexture;
layout(set = 1, binding = 49) uniform TEXTURE_2D g_xMaskTexture;

layout(location = 0) in vec2 in_var_TEXCOORD0;
layout(location = 1) in vec4 in_var_COLOR0;
layout(location = 0) out vec4 out_var_SV_Target;

vec2 _76;
vec2 _77;

void main()
{
    vec4 _306;
    if (QuadConstants.g_bUseDF != 0u)
    {
        vec2 _209 = dFdx(in_var_TEXCOORD0 * QuadConstants.g_fTextureSize);
        vec4 _217 = QuadConstants.g_xOuterGlowColour * in_var_COLOR0.w;
        float _243;
        float _244;
        if (QuadConstants.g_bUseMSDF != 0u)
        {
            vec4 _234 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearWrap), in_var_TEXCOORD0);
            float _235 = _234.x;
            float _236 = _234.y;
            _243 = _234.w;
            _244 = max(min(_235, _236), min(max(_235, _236), _234.z));
        }
        else
        {
            vec4 _229 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearWrap), in_var_TEXCOORD0);
            float _230 = _229.x;
            _243 = _230;
            _244 = _230;
        }
        float _248 = clamp(QuadConstants.g_fAntiAliasDistance * length(_209), 0.0, 1.0);
        float _262;
        if (QuadConstants.g_bAntiAlias != 0u)
        {
            _262 = smoothstep(clamp(QuadConstants.g_fTolerance - _248, 0.0, 1.0), clamp(QuadConstants.g_fTolerance + _248, 0.0, 1.0), _244);
        }
        else
        {
            _262 = float(_244 >= QuadConstants.g_fTolerance);
        }
        vec4 _284;
        if (QuadConstants.g_bOuterGlow != 0u)
        {
            vec4 _278 = _217;
            _278.w = _217.w * smoothstep(QuadConstants.g_fOuterGlowMin, QuadConstants.g_fOuterGlowMax, _243);
            _284 = mix(_278, in_var_COLOR0 * QuadConstants.g_fInnerAlpha, vec4(_262));
        }
        else
        {
            vec4 _270 = in_var_COLOR0;
            _270.w = in_var_COLOR0.w * _262;
            _284 = _270;
        }
        vec4 _305;
        if (QuadConstants.g_bOutline != 0u)
        {
            float _292 = QuadConstants.g_fTolerance + QuadConstants.g_fOutlineOffset;
            float _295 = _292 + QuadConstants.g_fOutlineHalfThickness;
            float _296 = _292 - QuadConstants.g_fOutlineHalfThickness;
            _305 = mix(_284, QuadConstants.g_xOutlineColour * in_var_COLOR0.w, vec4((smoothstep(_296, _296 + _248, _244) + smoothstep(_295, _295 - _248, _244)) - 1.0));
        }
        else
        {
            _305 = _284;
        }
        _306 = _305;
    }
    else
    {
        vec4 _205;
        if (QuadConstants.g_bUseTexture != 0u)
        {
            vec4 _204;
            if (QuadConstants.g_fBlendLerp > 0.0)
            {
                bool _139;
                vec4 _167;
                do
                {
                    _139 = QuadConstants.g_bUsePointMag != 0u;
                    if (_139)
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _167 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagWrap), in_var_TEXCOORD0);
                            break;
                        }
                        else
                        {
                            _167 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagClamp), in_var_TEXCOORD0);
                            break;
                        }
                    }
                    else
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _167 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearWrap), in_var_TEXCOORD0);
                            break;
                        }
                        else
                        {
                            _167 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearClamp), in_var_TEXCOORD0);
                            break;
                        }
                    }
                } while(false);
                vec2 _170 = in_var_TEXCOORD0 + QuadConstants.g_xBlendUVOffset;
                vec4 _200;
                do
                {
                    if (_139)
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _200 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagWrap), _170);
                            break;
                        }
                        else
                        {
                            _200 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagClamp), _170);
                            break;
                        }
                    }
                    else
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _200 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearWrap), _170);
                            break;
                        }
                        else
                        {
                            _200 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearClamp), _170);
                            break;
                        }
                    }
                } while(false);
                _204 = in_var_COLOR0 * mix(_167, _200, vec4(QuadConstants.g_fBlendLerp));
            }
            else
            {
                vec4 _132;
                do
                {
                    if (QuadConstants.g_bUsePointMag != 0u)
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _132 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagWrap), in_var_TEXCOORD0);
                            break;
                        }
                        else
                        {
                            _132 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagClamp), in_var_TEXCOORD0);
                            break;
                        }
                    }
                    else
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _132 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearWrap), in_var_TEXCOORD0);
                            break;
                        }
                        else
                        {
                            _132 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearClamp), in_var_TEXCOORD0);
                            break;
                        }
                    }
                } while(false);
                _204 = in_var_COLOR0 * _132;
            }
            _205 = _204;
        }
        else
        {
            _205 = in_var_COLOR0;
        }
        _306 = _205;
    }
    vec4 _344;
    if (QuadConstants.g_bUseRadialClip != 0u)
    {
        float _316 = length(gl_FragCoord.xy - QuadConstants.g_xClipCentre);
        float _340;
        if (_316 < QuadConstants.g_fInnerClipEndRadius)
        {
            _340 = clamp((_316 - QuadConstants.g_fInnerClipStartRadius) / max(QuadConstants.g_fInnerClipEndRadius - QuadConstants.g_fInnerClipStartRadius, 0.00999999977648258209228515625), 0.0, 1.0);
        }
        else
        {
            _340 = 1.0 - clamp((_316 - QuadConstants.g_fClipStartRadius) / max(QuadConstants.g_fClipEndRadius - QuadConstants.g_fClipStartRadius, 0.00999999977648258209228515625), 0.0, 1.0);
        }
        vec4 _343 = _306;
        _343.w = _306.w * _340;
        _344 = _343;
    }
    else
    {
        _344 = _306;
    }
    vec4 _407;
    if (QuadConstants.g_bUseTextureAlphaMask != 0u)
    {
        vec2 _353 = gl_FragCoord.xy - QuadConstants.g_xAlphaMaskOrigin;
		
        // The game uses the WINDOWS Resolution to compute the masks!
        // using the game Resolution..
        // FragCoord is in Screen Space (0-W, 0-H) and not in clip-space (-1, 1).
		if(gl_FragCoord.x > vk3d_params[VIEW].stereo.z * 0.4)
	   	{
            float factor = 1.0;
            if (vk3d_params[VIEW].custom_params.x == 0.0)
                factor = 0.7;
            if (vk3d_params[VIEW].custom_params.y == 1.0)
                factor = 0.8;
	   	     _353.x -= vk3d_params[VIEW].stereo.x * factor * vk3d_params[VIEW].stereo.z/2;
	    }
	    
        float _354 = _353.x;
        float _358 = _353.y;
        vec2 _363 = _77;
        _363.x = (_354 * QuadConstants.g_xAlphaMaskRotation.x) + (_358 * QuadConstants.g_xAlphaMaskRotation.y);
        vec2 _367 = _363;
        _367.y = (_358 * QuadConstants.g_xAlphaMaskRotation.x) - (_354 * QuadConstants.g_xAlphaMaskRotation.y);
        vec2 _370 = _367 * QuadConstants.g_xOneOverAlphaMaskDimensions;
        float _371 = _370.x;
        if ((_371 < 0.0) || (_371 > 1.0))
        {
            discard;
        }
        float _377 = _370.y;
        if ((_377 < 0.0) || (_377 > 1.0))
        {
            discard;
        }
        vec2 _390 = _76;
        _390.x = QuadConstants.g_xAlphaMaskUVs.x + (_371 * (QuadConstants.g_xAlphaMaskUVs.z - QuadConstants.g_xAlphaMaskUVs.x));
        vec2 _398 = _390;
        _398.y = QuadConstants.g_xAlphaMaskUVs.y + (_377 * (QuadConstants.g_xAlphaMaskUVs.w - QuadConstants.g_xAlphaMaskUVs.y));
        vec4 _406 = _344;
        _406.w = _344.w * SAMPLE_TEXTURE(SAMPLER_2D(g_xMaskTexture, g_xBilinearClamp), _398).x;
        _407 = _406;
    }
    else
    {
        _407 = _344;
    }
    vec4 _452;
    switch (QuadConstants.g_iBlendOperation)
    {
        case 0:
        {
            _452 = vec4(_407.xyz, 0.0);
            break;
        }
        case 1:
        {
            _452 = vec4(_407.xyz * _407.w, 1.0 - _407.w);
            break;
        }
        case 2:
        {
            _452 = vec4((vec3(1.0) - _407.xyz) * _407.w, 1.0 - _407.w);
            break;
        }
        case 3:
        {
            _452 = vec4(_407.xyz * _407.w, 1.0);
            break;
        }
        default:
        {
            _452 = vec4(_407.xyz * _407.w, 1.0 - _407.w);
            break;
        }
    }
    out_var_SV_Target = _452;
}






