// More skinning And black fog
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 0, scalar) uniform type_FrameConstants
{
    layout(row_major) mat4 g_xView;
    layout(row_major) mat4 g_xProj;
    layout(row_major) mat4 g_xViewProj;
    layout(row_major) mat4 g_xInvView;
    layout(row_major) mat4 g_xInvProj;
    layout(row_major) mat4 g_xInvViewProj;
    vec3 g_xCamPos;
    float g_fScaledTime;
    vec4 g_xTwoOverScreenDimensions;
    vec2 g_xCameraTanHalfFOV;
    vec2 g_xCameraFarClipValues;
    vec2 g_xRcpScreenDims;
    vec2 g_xDepthProjViewUnpack;
    vec4 g_axViewFrustumPlanes[6];
    ivec4 g_xScreenDimensions;
    vec4 g_xTessCutoffAndFactors;
    float g_fTessMaxDist;
    float g_fTessRcpRange;
    float g_fDisplacementScale;
    float g_fBackFaceCutoff;
    float g_fFoliageFadeInvDistance;
    float g_fFoliageFadePower;
    uint g_bFoliageFadeEnabled;
    float g_fEnvironmentDecalBias;
    float g_fInstanceDecalBias;
    vec3 g_xWindDirection;
    float g_fWindStrength;
    vec3 g_xSubsurfaceScatteringWeight;
    float g_fGlobalSamplerBias;
    vec3 g_xDeformationWindowCentre;
    float g_fDeformationWindowSize;
    float g_fDeformationUVDensity;
    float g_fDeformationNormalIntensity;
    float g_fRainfallIntensity;
    float g_fRainBaseWetness;
    vec3 g_xRainDirection;
} FrameConstants;

layout(set = 1, binding = 4, std140) uniform type_Asura_XRaySkin_ControlConstants
{
    uint g_bUseExternalRT;
    uint g_bOnlyUseExternalRT;
    uint g_bUseShadow;
} Asura_XRaySkin_ControlConstants;

layout(set = 1, binding = 12, std140) uniform type_CapsulePSConstants
{
    vec3 g_x3DCapsuleEndPos1;
    float g_x3DCapsuleRadius1;
    vec3 g_x3DCapsuleEndPos2;
    float g_x3DCapsuleRadius2;
    vec3 g_xCapsuleProjectionVector;
    float g_fProjectionRadius;
    vec3 g_xCapsuleProjectionUVector;
    float g_fSkinOutlineExtrudeDistance;
    vec3 g_xCapsuleProjectionVVector;
    float g_fPad;
    float g_fCutoutTexture1Influence;
    float g_fCutoutTexture2Influence;
    float g_fProjectionRadiusLerpToCapsuleRadius;
    uint g_uNumNoiseOctaves;
    vec4 g_auNoiseParameters[10];
    float g_fNoiseAlphaStart;
    float g_fNoiseAlphaPeak;
    float g_fNoiseAlphaEnd;
    float g_fInvNoiseFeather;
    vec4 g_xCutOutTextureUVTransform1[3];
    vec4 g_xCutOutTextureUVTransform2[3];
    vec2 g_x2DCapsuleEndPos1;
    vec2 g_x2DCapsuleEndPos2;
    float g_fConeOffset1;
    float g_fSphereRadius1;
    float g_fConeOffset2;
    float g_fSphereRadius2;
    vec2 g_x2DCapsuleVec;
    vec2 g_x2DCapsuleVecNormalised;
    float g_f2DCapsuleVecLength;
    float g_fCosTheta;
    float g_fInvCosTheta;
    float g_fInvTanTheta;
    vec4 g_xFadeParams;
    vec4 g_xCameraTanHalfFOV2;
    vec4 g_xSphereColour;
    uint g_bApplyNoiseToCapsulePass;
    uint g_bApplyNoiseToSkinPass;
    uint g_b3DCapsuleInCapsulePass;
    uint g_b3DCapsuleInSkinPass;
} CapsulePSConstants;

layout(set = 0, binding = 6) uniform sampler g_xFilteredWrap;
layout(set = 0, binding = 7) uniform sampler g_xFilteredClamp;
layout(set = 1, binding = 86) uniform TEXTURE_2D g_xCutoutTexture1;
layout(set = 1, binding = 87) uniform TEXTURE_2D g_xCutoutTexture2;
layout(set = 1, binding = 99) uniform TEXTURE_2D g_xScreenAlpha;

layout(location = 0) out vec4 out_var_SV_Target;

vec4 _121;
vec4 _128;

void main()
{
    vec3 _139 = vec3(((gl_FragCoord.xy * 2.0) * FrameConstants.g_xRcpScreenDims) - vec2(1.0), 0.0);
    bool _142 = CapsulePSConstants.g_b3DCapsuleInCapsulePass != 0u;
    bool _145 = CapsulePSConstants.g_bApplyNoiseToCapsulePass != 0u;
    vec4 _173;
    if (_142 || _145)
    {
        float _155 = FrameConstants.g_xDepthProjViewUnpack.x / (FrameConstants.g_xDepthProjViewUnpack.y - gl_FragCoord.z);
        //_173 = vec4((FrameConstants.g_xCameraTanHalfFOV * _155) * (((gl_FragCoord.xy + FrameConstants.g_xTwoOverScreenDimensions.zw) * FrameConstants.g_xTwoOverScreenDimensions.xy) - vec2(1.0)), _155, 1.0) * FrameConstants.g_xInvView;
        _173 = vec4((FrameConstants.g_xCameraTanHalfFOV * _155) * (((gl_FragCoord.xy + FrameConstants.g_xTwoOverScreenDimensions.zw) * FrameConstants.g_xTwoOverScreenDimensions.xy) - vec2(1.0)), _155, 1.0);
        _173.x -= vk3d_params[VIEW].stereo.x * (_155 - vk3d_params[VIEW].stereo.y) * FrameConstants.g_xInvProj[0][0];
        _173 = _173 * FrameConstants.g_xInvView;
    }
    else
    {
        _173 = _121;
    }
    float _758;
    float _759;
    if (_142)
    {
        vec3 _261 = CapsulePSConstants.g_x3DCapsuleEndPos2 - CapsulePSConstants.g_x3DCapsuleEndPos1;
        float _262 = length(_261);
        vec3 _263 = _173.xyz - CapsulePSConstants.g_x3DCapsuleEndPos1;
        vec2 _264 = _139.xy;
        vec2 _270 = vec2(1.0, CapsulePSConstants.g_xCameraTanHalfFOV2.z);
        vec2 _271 = (_264 - CapsulePSConstants.g_x2DCapsuleEndPos1) / _270;
        float _272 = length(_271);
        float _334;
        float _335;
        if (CapsulePSConstants.g_f2DCapsuleVecLength > 9.9999997473787516355514526367188e-05)
        {
            float _284 = dot(_271, CapsulePSConstants.g_x2DCapsuleVecNormalised);
            float _332;
            float _333;
            if ((_272 < 0.001000000047497451305389404296875) || ((_284 / _272) < CapsulePSConstants.g_fCosTheta))
            {
                _332 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius1;
                _333 = _272;
            }
            else
            {
                float _298 = length((_264 - CapsulePSConstants.g_x2DCapsuleEndPos2) / _270);
                float _327;
                float _328;
                if ((_298 < 0.001000000047497451305389404296875) || (((_284 - CapsulePSConstants.g_f2DCapsuleVecLength) / _298) > CapsulePSConstants.g_fCosTheta))
                {
                    _327 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius2;
                    _328 = _298;
                }
                else
                {
                    float _312 = length(_271 - (CapsulePSConstants.g_x2DCapsuleVecNormalised * _284)) * CapsulePSConstants.g_fInvTanTheta;
                    _327 = mix(CapsulePSConstants.g_fSphereRadius1, CapsulePSConstants.g_fSphereRadius2, (_284 - _312) / CapsulePSConstants.g_f2DCapsuleVecLength) * CapsulePSConstants.g_xFadeParams.w;
                    _328 = _312 * CapsulePSConstants.g_fInvCosTheta;
                }
                _332 = _327;
                _333 = _328;
            }
            _334 = _332;
            _335 = _333;
        }
        else
        {
            _334 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius1;
            _335 = _272;
        }
        float _338 = clamp(1.0 - (_335 / _334), 0.0, 1.0);
        float _756;
        float _757;
        if (_262 > 0.00999999977648258209228515625)
        {
            float _442 = dot(_263, _261 / vec3(_262));
            float _754;
            float _755;
            if (_442 < 0.0)
            {
                float _659 = CapsulePSConstants.g_x3DCapsuleRadius1 * CapsulePSConstants.g_xFadeParams.w;
                float _663 = clamp(1.0 - (length(_263) / _659), 0.0, 1.0);
                float _664 = min(_663, _338);
                bool _667 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
                bool _670 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
                float _753;
                if (_667 || _670)
                {
                    float _679 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, _659, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                    vec3 _684 = _263 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _263));
                    float _688 = dot(_684, CapsulePSConstants.g_xCapsuleProjectionUVector) * _679;
                    float _692 = dot(_684, CapsulePSConstants.g_xCapsuleProjectionVVector) * _679;
                    float _722;
                    if (_667)
                    {
                        _722 = mix(_664, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_688 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_692 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_688 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_692 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _664 * CapsulePSConstants.g_fCutoutTexture1Influence);
                    }
                    else
                    {
                        _722 = _664;
                    }
                    float _752;
                    if (_670)
                    {
                        _752 = mix(_722, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_688 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) + (_692 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_688 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_692 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _722 * CapsulePSConstants.g_fCutoutTexture2Influence);
                    }
                    else
                    {
                        _752 = _722;
                    }
                    _753 = _752;
                }
                else
                {
                    _753 = _664;
                }
                _754 = _663;
                _755 = _753;
            }
            else
            {
                float _655;
                float _656;
                if (_442 > _262)
                {
                    float _560 = CapsulePSConstants.g_x3DCapsuleRadius2 * CapsulePSConstants.g_xFadeParams.w;
                    float _564 = clamp(1.0 - (length(_263) / _560), 0.0, 1.0);
                    float _565 = min(_564, _338);
                    bool _568 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
                    bool _571 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
                    float _654;
                    if (_568 || _571)
                    {
                        float _580 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, _560, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                        vec3 _585 = _263 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _263));
                        float _589 = dot(_585, CapsulePSConstants.g_xCapsuleProjectionUVector) * _580;
                        float _593 = dot(_585, CapsulePSConstants.g_xCapsuleProjectionVVector) * _580;
                        float _623;
                        if (_568)
                        {
                            _623 = mix(_565, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_589 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_593 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_589 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_593 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _565 * CapsulePSConstants.g_fCutoutTexture1Influence);
                        }
                        else
                        {
                            _623 = _565;
                        }
                        float _653;
                        if (_571)
                        {
                            _653 = mix(_623, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_589 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) + (_593 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_589 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_593 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _623 * CapsulePSConstants.g_fCutoutTexture2Influence);
                        }
                        else
                        {
                            _653 = _623;
                        }
                        _654 = _653;
                    }
                    else
                    {
                        _654 = _565;
                    }
                    _655 = _564;
                    _656 = _654;
                }
                else
                {
                    float _452 = clamp(_442 / _262, 0.0, 1.0);
                    float _458 = CapsulePSConstants.g_xFadeParams.w * mix(CapsulePSConstants.g_x3DCapsuleRadius1, CapsulePSConstants.g_x3DCapsuleRadius2, _452);
                    vec3 _460 = _261 * (_452 * _262);
                    float _465 = clamp(1.0 - (length(_263 - _460) / _458), 0.0, 1.0);
                    float _466 = min(_465, _338);
                    vec3 _468 = _173.xyz - (CapsulePSConstants.g_x3DCapsuleEndPos1 + _460);
                    bool _471 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
                    bool _474 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
                    float _557;
                    if (_471 || _474)
                    {
                        float _483 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, _458, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                        vec3 _488 = _468 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _468));
                        float _492 = dot(_488, CapsulePSConstants.g_xCapsuleProjectionUVector) * _483;
                        float _496 = dot(_488, CapsulePSConstants.g_xCapsuleProjectionVVector) * _483;
                        float _526;
                        if (_471)
                        {
                            _526 = mix(_466, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_492 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_496 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_492 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_496 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _466 * CapsulePSConstants.g_fCutoutTexture1Influence);
                        }
                        else
                        {
                            _526 = _466;
                        }
                        float _556;
                        if (_474)
                        {
                            _556 = mix(_526, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_492 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) + (_496 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_492 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_496 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _526 * CapsulePSConstants.g_fCutoutTexture2Influence);
                        }
                        else
                        {
                            _556 = _526;
                        }
                        _557 = _556;
                    }
                    else
                    {
                        _557 = _466;
                    }
                    _655 = _465;
                    _656 = _557;
                }
                _754 = _655;
                _755 = _656;
            }
            _756 = _754;
            _757 = _755;
        }
        else
        {
            float _345 = CapsulePSConstants.g_x3DCapsuleRadius1 * CapsulePSConstants.g_xFadeParams.w;
            float _349 = clamp(1.0 - (length(_263) / _345), 0.0, 1.0);
            float _350 = min(_349, _338);
            bool _353 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
            bool _356 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
            float _439;
            if (_353 || _356)
            {
                float _365 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, _345, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                vec3 _370 = _263 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _263));
                float _374 = dot(_370, CapsulePSConstants.g_xCapsuleProjectionUVector) * _365;
                float _378 = dot(_370, CapsulePSConstants.g_xCapsuleProjectionVVector) * _365;
                float _408;
                if (_353)
                {
                    _408 = mix(_350, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_374 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_378 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_374 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_378 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _350 * CapsulePSConstants.g_fCutoutTexture1Influence);
                }
                else
                {
                    _408 = _350;
                }
                float _438;
                if (_356)
                {
                    _438 = mix(_408, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_374 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) + (_378 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_374 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_378 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _408 * CapsulePSConstants.g_fCutoutTexture2Influence);
                }
                else
                {
                    _438 = _408;
                }
                _439 = _438;
            }
            else
            {
                _439 = _350;
            }
            _756 = _349;
            _757 = _439;
        }
        _758 = _756;
        _759 = _757;
    }
    else
    {
        vec2 _179 = _139.xy;
        vec2 _185 = vec2(1.0, CapsulePSConstants.g_xCameraTanHalfFOV2.z);
        vec2 _186 = (_179 - CapsulePSConstants.g_x2DCapsuleEndPos1) / _185;
        float _187 = length(_186);
        float _249;
        float _250;
        if (CapsulePSConstants.g_f2DCapsuleVecLength > 9.9999997473787516355514526367188e-05)
        {
            float _199 = dot(_186, CapsulePSConstants.g_x2DCapsuleVecNormalised);
            float _247;
            float _248;
            if ((_187 < 0.001000000047497451305389404296875) || ((_199 / _187) < CapsulePSConstants.g_fCosTheta))
            {
                _247 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius1;
                _248 = _187;
            }
            else
            {
                float _213 = length((_179 - CapsulePSConstants.g_x2DCapsuleEndPos2) / _185);
                float _242;
                float _243;
                if ((_213 < 0.001000000047497451305389404296875) || (((_199 - CapsulePSConstants.g_f2DCapsuleVecLength) / _213) > CapsulePSConstants.g_fCosTheta))
                {
                    _242 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius2;
                    _243 = _213;
                }
                else
                {
                    float _227 = length(_186 - (CapsulePSConstants.g_x2DCapsuleVecNormalised * _199)) * CapsulePSConstants.g_fInvTanTheta;
                    _242 = mix(CapsulePSConstants.g_fSphereRadius1, CapsulePSConstants.g_fSphereRadius2, (_199 - _227) / CapsulePSConstants.g_f2DCapsuleVecLength) * CapsulePSConstants.g_xFadeParams.w;
                    _243 = _227 * CapsulePSConstants.g_fInvCosTheta;
                }
                _247 = _242;
                _248 = _243;
            }
            _249 = _247;
            _250 = _248;
        }
        else
        {
            _249 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius1;
            _250 = _187;
        }
        // MONO FOG
        float _253 = clamp(1.0 - (_250 / _249), 0.0, 1.0)*0;
        _758 = _253;
        _759 = _253;
    }
    float _761 = 2.0 * _759;
    float _764 = clamp((_759 > 0.5) ? (2.0 - _761) : _761, 0.0, 1.0);
    float _1139;
    if (_145)
    {
        float _1138;
        do
        {
            if (CapsulePSConstants.g_uNumNoiseOctaves == 0u)
            {
                _1138 = _759;
                break;
            }
            else
            {
                float _776;
                _776 = 0.0;
                for (uint _779 = 0u; _779 < CapsulePSConstants.g_uNumNoiseOctaves; )
                {
                    vec4 _792 = vec4(_173.xyz, FrameConstants.g_fScaledTime) * CapsulePSConstants.g_auNoiseParameters[_779].xxxy;
                    vec4 _796 = floor(_792 + vec4(dot(_792, vec4(0.309017002582550048828125))));
                    vec4 _800 = (_792 - _796) + vec4(dot(_796, vec4(0.13819660246372222900390625)));
                    vec3 _803 = step(_800.yzw, _800.xxx);
                    vec3 _806 = step(_800.zww, _800.yyz);
                    vec4 _812 = _128;
                    _812.x = (_803.x + _803.y) + _803.z;
                    vec3 _813 = vec3(1.0) - _803;
                    vec4 _820 = vec4(_812.x, _813.x, _813.y, _813.z);
                    _820.y = _813.x + (_806.x + _806.y);
                    vec2 _824 = _820.zw + (vec2(1.0) - _806.xy);
                    float _826 = _806.z;
                    vec4 _829 = vec4(_820.x, _820.y, _824.x, _824.y);
                    _829.z = _824.x + _826;
                    vec4 _833 = _829;
                    _833.w = _824.y + (1.0 - _826);
                    vec4 _834 = clamp(_833, vec4(0.0), vec4(1.0));
                    vec4 _836 = clamp(_833 - vec4(1.0), vec4(0.0), vec4(1.0));
                    vec4 _838 = clamp(_833 - vec4(2.0), vec4(0.0), vec4(1.0));
                    vec4 _840 = (_800 - _838) + vec4(0.13819660246372222900390625);
                    vec4 _842 = (_800 - _836) + vec4(0.2763932049274444580078125);
                    vec4 _844 = (_800 - _834) + vec4(0.4145897924900054931640625);
                    vec4 _845 = _800 + vec4(-0.447213590145111083984375);
                    vec4 _849 = _796 - (floor(_796 * 0.00346020772121846675872802734375) * 289.0);
                    float _850 = _849.w;
                    float _853 = ((_850 * _850) * 34.0) + _850;
                    float _858 = _849.z;
                    float _859 = (_853 - (floor(_853 * 0.00346020772121846675872802734375) * 289.0)) + _858;
                    float _862 = ((_859 * _859) * 34.0) + _859;
                    float _867 = _849.y;
                    float _868 = (_862 - (floor(_862 * 0.00346020772121846675872802734375) * 289.0)) + _867;
                    float _871 = ((_868 * _868) * 34.0) + _868;
                    float _876 = _849.x;
                    float _877 = (_871 - (floor(_871 * 0.00346020772121846675872802734375) * 289.0)) + _876;
                    float _880 = ((_877 * _877) * 34.0) + _877;
                    vec4 _890 = vec4(_850) + vec4(_838.w, _836.w, _834.w, 1.0);
                    vec4 _893 = ((_890 * _890) * 34.0) + _890;
                    vec4 _904 = ((_893 - (floor(_893 * 0.00346020772121846675872802734375) * 289.0)) + vec4(_858)) + vec4(_838.z, _836.z, _834.z, 1.0);
                    vec4 _907 = ((_904 * _904) * 34.0) + _904;
                    vec4 _918 = ((_907 - (floor(_907 * 0.00346020772121846675872802734375) * 289.0)) + vec4(_867)) + vec4(_838.y, _836.y, _834.y, 1.0);
                    vec4 _921 = ((_918 * _918) * 34.0) + _918;
                    vec4 _932 = ((_921 - (floor(_921 * 0.00346020772121846675872802734375) * 289.0)) + vec4(_876)) + vec4(_838.x, _836.x, _834.x, 1.0);
                    vec4 _935 = ((_932 * _932) * 34.0) + _932;
                    vec4 _939 = _935 - (floor(_935 * 0.00346020772121846675872802734375) * 289.0);
                    vec3 _945 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * (_880 - (floor(_880 * 0.00346020772121846675872802734375) * 289.0))) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                    float _950 = 1.5 - dot(abs(_945.xyz), vec3(1.0));
                    vec4 _951 = vec4(_945.x, _945.y, _945.z, _128.w);
                    _951.w = _950;
                    vec3 _960 = _951.xyz - vec3(ivec3(sign(_951.xyz)) * ivec3(int(_950 < 0.0)));
                    vec4 _961 = vec4(_960.x, _960.y, _960.z, _951.w);
                    vec3 _968 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _939.x) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                    float _973 = 1.5 - dot(abs(_968.xyz), vec3(1.0));
                    vec4 _974 = vec4(_968.x, _968.y, _968.z, _128.w);
                    _974.w = _973;
                    vec3 _983 = _974.xyz - vec3(ivec3(sign(_974.xyz)) * ivec3(int(_973 < 0.0)));
                    vec4 _984 = vec4(_983.x, _983.y, _983.z, _974.w);
                    vec3 _991 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _939.y) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                    float _996 = 1.5 - dot(abs(_991.xyz), vec3(1.0));
                    vec4 _997 = vec4(_991.x, _991.y, _991.z, _128.w);
                    _997.w = _996;
                    vec3 _1006 = _997.xyz - vec3(ivec3(sign(_997.xyz)) * ivec3(int(_996 < 0.0)));
                    vec4 _1007 = vec4(_1006.x, _1006.y, _1006.z, _997.w);
                    vec3 _1014 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _939.z) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                    float _1019 = 1.5 - dot(abs(_1014.xyz), vec3(1.0));
                    vec4 _1020 = vec4(_1014.x, _1014.y, _1014.z, _128.w);
                    _1020.w = _1019;
                    vec3 _1029 = _1020.xyz - vec3(ivec3(sign(_1020.xyz)) * ivec3(int(_1019 < 0.0)));
                    vec4 _1030 = vec4(_1029.x, _1029.y, _1029.z, _1020.w);
                    vec3 _1037 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _939.w) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                    float _1042 = 1.5 - dot(abs(_1037.xyz), vec3(1.0));
                    vec4 _1043 = vec4(_1037.x, _1037.y, _1037.z, _128.w);
                    _1043.w = _1042;
                    vec3 _1052 = _1043.xyz - vec3(ivec3(sign(_1043.xyz)) * ivec3(int(_1042 < 0.0)));
                    vec4 _1053 = vec4(_1052.x, _1052.y, _1052.z, _1043.w);
                    vec4 _1059 = inversesqrt(vec4(dot(_961, _961), dot(_984, _984), dot(_1007, _1007), dot(_1030, _1030)));
                    vec3 _1076 = max(vec3(0.60000002384185791015625) - vec3(dot(_800, _800), dot(_840, _840), dot(_842, _842)), vec3(0.0));
                    vec2 _1081 = max(vec2(0.60000002384185791015625) - vec2(dot(_844, _844), dot(_845, _845)), vec2(0.0));
                    vec3 _1082 = _1076 * _1076;
                    vec2 _1083 = _1081 * _1081;
                    _776 += ((49.0 * (dot(_1082 * _1082, vec3(dot(_961 * _1059.x, _800), dot(_984 * _1059.y, _840), dot(_1007 * _1059.z, _842))) + dot(_1083 * _1083, vec2(dot(_1030 * _1059.w, _844), dot(_1053 * inversesqrt(dot(_1053, _1053)), _845))))) * CapsulePSConstants.g_auNoiseParameters[_779].z);
                    _779++;
                    continue;
                }
                if (_758 <= CapsulePSConstants.g_fNoiseAlphaStart)
                {
                    _1138 = _759;
                    break;
                }
                if (_759 >= CapsulePSConstants.g_fNoiseAlphaEnd)
                {
                    _1138 = _759;
                    break;
                }
                float _1125;
                if (_759 < CapsulePSConstants.g_fNoiseAlphaPeak)
                {
                    _1125 = clamp((_759 - CapsulePSConstants.g_fNoiseAlphaStart) / (CapsulePSConstants.g_fNoiseAlphaPeak - CapsulePSConstants.g_fNoiseAlphaStart), 0.0, 1.0);
                }
                else
                {
                    _1125 = clamp(1.0 - ((_759 - CapsulePSConstants.g_fNoiseAlphaPeak) / (CapsulePSConstants.g_fNoiseAlphaEnd - CapsulePSConstants.g_fNoiseAlphaPeak)), 0.0, 1.0);
                }
                _1138 = mix(_759, (1.0 - clamp((((min(1.0, max(-1.0, _776)) * 0.5) + 0.5) - _759) * CapsulePSConstants.g_fInvNoiseFeather, 0.0, 1.0)) * _759, _1125);
                break;
            }
        } while(false);
        _1139 = _1138;
    }
    else
    {
        _1139 = _759;
    }
    float _1151 = 1.0 - pow(1.0 - clamp((_1139 * CapsulePSConstants.g_xFadeParams.x) + CapsulePSConstants.g_xFadeParams.y, 0.0, 1.0), CapsulePSConstants.g_xFadeParams.z);
    float _1167;
    if (Asura_XRaySkin_ControlConstants.g_bUseExternalRT != 0u)
    {
        _1167 = _1151 * clamp((SAMPLE_TEXTURE(SAMPLER_2D(g_xScreenAlpha, g_xFilteredClamp), gl_FragCoord.xy * FrameConstants.g_xRcpScreenDims).x * 2.0) - 1.0, 0.0, 1.0);
    }
    else
    {
        _1167 = _1151;
    }
    out_var_SV_Target = vec4((CapsulePSConstants.g_xSphereColour.xyz * _764) * _764, _1167 * CapsulePSConstants.g_xSphereColour.w);
}


