
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    uvec3 g_xPad;
};

layout(set = 2, binding = 7, scalar) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 3, binding = 12, std140) uniform type_InstanceSingleParams
{
    vec4 g_xInstancePosition;
    vec4 g_xTransform0;
    vec4 g_xTransform1;
    vec4 g_xTransform2;
} InstanceSingleParams;

layout(set = 3, binding = 11, std140) uniform type_MeshConstants
{
    vec3 g_xPrecisionOffset;
    uint g_bIsBillboard;
    vec3 g_xPrecisionScale;
    uint g_bIsInteractive;
} MeshConstants;

layout(location = 0) in vec4 in_var_POSITION0;
layout(location = 1) in vec4 in_var_TEXCOORD0;
layout(location = 2) in vec3 in_var_NORMAL;
layout(location = 3) in vec3 in_var_TESSNORMAL;

vec4 _43;

void main()
{
    vec3 _61 = (in_var_POSITION0.xyz * MeshConstants.g_xPrecisionScale) + MeshConstants.g_xPrecisionOffset;
    vec4 _63 = _43;
    _63.x = dot(_61, InstanceSingleParams.g_xTransform0.xyz);
    vec4 _65 = _63;
    _65.y = dot(_61, InstanceSingleParams.g_xTransform1.xyz);
    vec4 _67 = _65;
    _67.z = dot(_61, InstanceSingleParams.g_xTransform2.xyz);
    vec4 _94;
    if (MeshConstants.g_bIsInteractive != 0u)
    {
        vec4 _76 = _43;
        _76.x = InstanceSingleParams.g_xTransform0.w;
        vec4 _78 = _76;
        _78.y = InstanceSingleParams.g_xTransform1.w;
        vec4 _80 = _78;
        _80.z = InstanceSingleParams.g_xTransform2.w;
        vec3 _86 = cross(_80.xyz, _67.xyz);
        vec3 _92 = (((_86 * sqrt(clamp(1.0 - dot(_80.xyz, _80.xyz), 0.0, 1.0))) + cross(_80.xyz, _86)) * (2.0 * in_var_POSITION0.w)) + _67.xyz;
        _94 = vec4(_92.x, _92.y, _92.z, _67.w);
    }
    else
    {
        _94 = _67;
    }
    gl_Position = vec4(_94.xyz + InstanceSingleParams.g_xInstancePosition.xyz, 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
}

