#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 9, std140) uniform type_FXAAConstants
{
    vec2 g_xRcpFrame;
} FXAAConstants;

layout(set = 0, binding = 3) uniform sampler g_xBilinearClamp;
layout(set = 1, binding = 50) uniform TEXTURE_2D g_xPostToneMapFrameBufferTexture;

layout(location = 0) in vec2 in_var_TEXCOORD0;
layout(location = 0) out vec4 out_var_SV_Target;

vec2 _50;
vec4 _51;
vec2 _52;

void main()
{
    vec4 _353;
    do
    {
        vec2 _62 = _50;
        _62.x = in_var_TEXCOORD0.x;
        vec2 _64 = _62;
        _64.y = in_var_TEXCOORD0.y;
        vec4 _66 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _64, 0.0);
        vec4 _68 = TEXTURE_GATHER(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _64, 3);
        vec4 _70 = TEXTURE_GATHER_OFFSET(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _64, ivec2(-1), 3);
        float _71 = _68.x;
        float _72 = _66.w;
        float _75 = _68.z;
        float _78 = _70.z;
        float _79 = _70.x;
        float _82 = max(max(_78, _79), max(_75, max(_71, _72)));
        float _85 = _82 - min(min(_78, _79), min(_75, min(_71, _72)));
        if (_85 < max(0.083333335816860198974609375, _82 * 0.16666667163372039794921875))
        {
            _353 = _66;
            break;
        }
        vec4 _91 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _64, 0.0, ivec2(1, -1));
        float _92 = _91.w;
        vec4 _94 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
TEXTURE_LOD_OFFSET(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _64, 0.0, ivec2(-1, 1));
        float _95 = _94.w;
        float _96 = _78 + _71;
        float _97 = _79 + _75;
        float _100 = (-2.0) * _72;
        float _103 = _68.y;
        float _104 = _92 + _103;
        float _105 = _70.w;
        float _111 = _105 + _95;
        bool _131 = (abs(((-2.0) * _79) + _111) + ((abs(_100 + _96) * 2.0) + abs(((-2.0) * _75) + _104))) >= (abs(((-2.0) * _71) + (_95 + _103)) + ((abs(_100 + _97) * 2.0) + abs(((-2.0) * _78) + (_105 + _92))));
        bool _134 = !_131;
        vec4 _138;
        if (_134)
        {
            vec4 _137 = _51;
            _137.z = _79;
            _138 = _137;
        }
        else
        {
            _138 = _70;
        }
        vec4 _142;
        if (_134)
        {
            vec4 _141 = _51;
            _141.x = _75;
            _142 = _141;
        }
        else
        {
            _142 = _68;
        }
        float _146;
        if (_131)
        {
            _146 = FXAAConstants.g_xRcpFrame.y;
        }
        else
        {
            _146 = FXAAConstants.g_xRcpFrame.x;
        }
        float _155 = abs(_138.z - _72);
        float _156 = abs(_142.x - _72);
        bool _157 = _155 >= _156;
        float _162;
        if (_157)
        {
            _162 = -_146;
        }
        else
        {
            _162 = _146;
        }
        float _165 = clamp(abs(((((_96 + _97) * 2.0) + (_111 + _104)) * 0.083333335816860198974609375) - _72) * (1.0 / _85), 0.0, 1.0);
        float _166 = _134 ? 0.0 : FXAAConstants.g_xRcpFrame.x;
        float _168 = _131 ? 0.0 : FXAAConstants.g_xRcpFrame.y;
        vec2 _174;
        if (_134)
        {
            vec2 _173 = _64;
            _173.x = in_var_TEXCOORD0.x + (_162 * 0.5);
            _174 = _173;
        }
        else
        {
            _174 = _64;
        }
        vec2 _181;
        if (_131)
        {
            vec2 _180 = _174;
            _180.y = _174.y + (_162 * 0.5);
            _181 = _180;
        }
        else
        {
            _181 = _174;
        }
        float _183 = _166 * 1.5;
        float _184 = _181.x - _183;
        vec2 _185 = _50;
        _185.x = _184;
        float _187 = _168 * 1.5;
        vec2 _189 = _185;
        _189.y = _181.y - _187;
        float _190 = _181.x + _183;
        vec2 _191 = _50;
        _191.x = _190;
        vec2 _193 = _191;
        _193.y = _181.y + _187;
        float _205 = max(_155, _156) * 0.25;
        float _206 = ((!_157) ? (_142.x + _72) : (_138.z + _72)) * 0.5;
        float _208 = (((-2.0) * _165) + 3.0) * (_165 * _165);
        bool _209 = (_72 - _206) < 0.0;
        float _210 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _189, 0.0).w - _206;
        float _211 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _193, 0.0).w - _206;
        bool _216 = !(abs(_210) >= _205);
        vec2 _222;
        if (_216)
        {
            vec2 _221 = _189;
            _221.x = _184 - (_166 * 2.0);
            _222 = _221;
        }
        else
        {
            _222 = _189;
        }
        vec2 _229;
        if (_216)
        {
            vec2 _228 = _222;
            _228.y = _222.y - (_168 * 2.0);
            _229 = _228;
        }
        else
        {
            _229 = _222;
        }
        bool _230 = !(abs(_211) >= _205);
        vec2 _237;
        if (_230)
        {
            vec2 _236 = _193;
            _236.x = _190 + (_166 * 2.0);
            _237 = _236;
        }
        else
        {
            _237 = _193;
        }
        vec2 _244;
        if (_230)
        {
            vec2 _243 = _237;
            _243.y = _237.y + (_168 * 2.0);
            _244 = _243;
        }
        else
        {
            _244 = _237;
        }
        vec2 _301;
        vec2 _302;
        float _303;
        float _304;
        if (_216 || _230)
        {
            float _252;
            if (_216)
            {
                _252 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _229, 0.0).w;
            }
            else
            {
                _252 = _210;
            }
            float _258;
            if (_230)
            {
                _258 = TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _244, 0.0).w;
            }
            else
            {
                _258 = _211;
            }
            float _262;
            if (_216)
            {
                _262 = _252 - _206;
            }
            else
            {
                _262 = _252;
            }
            float _266;
            if (_230)
            {
                _266 = _258 - _206;
            }
            else
            {
                _266 = _258;
            }
            bool _271 = !(abs(_262) >= _205);
            vec2 _278;
            if (_271)
            {
                vec2 _277 = _229;
                _277.x = _229.x - (_166 * 8.0);
                _278 = _277;
            }
            else
            {
                _278 = _229;
            }
            vec2 _285;
            if (_271)
            {
                vec2 _284 = _278;
                _284.y = _278.y - (_168 * 8.0);
                _285 = _284;
            }
            else
            {
                _285 = _278;
            }
            bool _286 = !(abs(_266) >= _205);
            vec2 _293;
            if (_286)
            {
                vec2 _292 = _244;
                _292.x = _244.x + (_166 * 8.0);
                _293 = _292;
            }
            else
            {
                _293 = _244;
            }
            vec2 _300;
            if (_286)
            {
                vec2 _299 = _293;
                _299.y = _293.y + (_168 * 8.0);
                _300 = _299;
            }
            else
            {
                _300 = _293;
            }
            _301 = _300;
            _302 = _285;
            _303 = _266;
            _304 = _262;
        }
        else
        {
            _301 = _244;
            _302 = _229;
            _303 = _211;
            _304 = _210;
        }
        float _313;
        if (_134)
        {
            _313 = in_var_TEXCOORD0.y - _302.y;
        }
        else
        {
            _313 = in_var_TEXCOORD0.x - _302.x;
        }
        float _318;
        if (_134)
        {
            _318 = _301.y - in_var_TEXCOORD0.y;
        }
        else
        {
            _318 = _301.x - in_var_TEXCOORD0.x;
        }
        float _333 = max(((_313 < _318) ? ((_304 < 0.0) != _209) : ((_303 < 0.0) != _209)) ? ((min(_313, _318) * ((-1.0) / (_318 + _313))) + 0.5) : 0.0, (_208 * _208) * 0.75);
        vec2 _339;
        if (_134)
        {
            vec2 _338 = _64;
            _338.x = in_var_TEXCOORD0.x + (_333 * _162);
            _339 = _338;
        }
        else
        {
            _339 = _64;
        }
        vec2 _346;
        if (_131)
        {
            vec2 _345 = _339;
            _345.y = _339.y + (_333 * _162);
            _346 = _345;
        }
        else
        {
            _346 = _339;
        }
        _353 = vec4(TEXTURE_LOD(SAMPLER_2D(g_xPostToneMapFrameBufferTexture, g_xBilinearClamp), _346, 0.0).xyz, _72);
        break;
    } while(false);
    out_var_SV_Target = _353;
}

