#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct StaticMaterial
{
    float m_fMaterialIndex;
    vec3 m_xAlbedoTint;
    vec4 m_xParallaxUVScaleAndSpeed;
    float m_fRefractivity;
    float m_fParallaxScale;
    float m_fParallaxBias;
    float m_fAlbedoDetailUVScale;
    float m_fAlbedoDetailValueScale;
    float m_fNormalDetailUVScale;
    float m_fNormalDetailValueScale;
    float m_fMaterialModel;
    float m_fSlopeShaderUVScale;
    float m_fSlopeShaderStrength;
    float m_fSlopeShaderThreshold;
    float m_fSlopeShaderPower;
    float m_fSlopeShaderThresFactor;
    vec3 m_xSlopeShaderNormal;
    vec3 m_xSlopeShaderForward;
    float m_fPad;
    float m_fInvHeightmapBlendSoftness;
    float m_fDecalNormalThresholdA;
    float m_fDecalNormalThresholdB;
    float m_fFoliageCosClippingAngle;
    float m_fWindResponsiveness;
    uint m_bRefractionBlendBackground;
    uint m_bIsDecal;
    uint m_bIsFoliage;
    uint m_bReflectBackfaceNormalsWithView;
    uint m_bUseBinarySearchForParallax;
    uint m_bUseAlbedo;
    uint m_bUseNormalMap;
    uint m_bUseMetalMap;
    uint m_bUseTransparencyMap;
    uint m_bUseSelfIlluminationMap;
    uint m_bUseParallaxMap;
    uint m_bUseEnvironmentMap;
    uint m_bUseAlbedoDetailMap;
    uint m_bUseNormalDetailMap;
    uint m_bUseSelfIlluminationGraph;
    uint m_bUseRefraction;
    uint m_bUseTransparencyGraph;
    uint m_bUseSlopeShader;
    uint m_bUseHairFlowMap;
    uint m_bUseHairNoiseMap;
    uint m_bHasParallaxMap;
    uint m_bUseSlopeShaderAlbedoMap1;
    uint m_bUseSlopeShaderNormalMap1;
    uint m_bUseSlopeShaderTransparencyMap1;
    uint m_bUseDamageThresholdMap;
    uint m_bUseFaceWrinkles;
    uint m_bUseRippleMap;
    uint m_uAlbedoMap;
    uint m_uAlbedoDetailMap;
    uint m_uNormalMap;
    uint m_uNormalDetailMap;
    uint m_uMetalMap;
    uint m_uTransparencyMap;
    uint m_uSelfIlluminationMap;
    uint m_uParallaxMap;
    uint m_uHairFlowMap;
    uint m_uHairNoiseMap;
    uint m_uSlopeShaderAlbedoMap;
    uint m_uSlopeShaderNormalMap;
    uint m_uSlopeShaderTransparencyMap;
    uint m_uDamageThresholdMap;
    uint m_uWrinkleMask_Compressed;
    uint m_uWrinkleMask_Stretched;
    uint m_uWrinkleMap_Compressed;
    uint m_uWrinkleMap_Stretched;
    uint m_uRippleMap;
    uint m_bIsTransmissive;
    uint m_bIsDeformable;
    float m_fDeformableHeight;
    uint m_uDeformableDetailAlbedoMap;
    uint m_uDeformableDetailNormalMap;
    float m_fDeformableDetailMapUVScale;
    float m_fDeformableDetailBlendPower;
    float m_fPorosity;
    uint m_uStructuredBufferIndex;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 0, scalar) uniform type_FrameConstants
{
    layout(row_major) mat4 g_xView;
    layout(row_major) mat4 g_xProj;
    layout(row_major) mat4 g_xViewProj;
    layout(row_major) mat4 g_xInvView;
    layout(row_major) mat4 g_xInvProj;
    layout(row_major) mat4 g_xInvViewProj;
    vec3 g_xCamPos;
    float g_fScaledTime;
    vec4 g_xTwoOverScreenDimensions;
    vec2 g_xCameraTanHalfFOV;
    vec2 g_xCameraFarClipValues;
    vec2 g_xRcpScreenDims;
    vec2 g_xDepthProjViewUnpack;
    vec4 g_axViewFrustumPlanes[6];
    ivec4 g_xScreenDimensions;
    vec4 g_xTessCutoffAndFactors;
    float g_fTessMaxDist;
    float g_fTessRcpRange;
    float g_fDisplacementScale;
    float g_fBackFaceCutoff;
    float g_fFoliageFadeInvDistance;
    float g_fFoliageFadePower;
    uint g_bFoliageFadeEnabled;
    float g_fEnvironmentDecalBias;
    float g_fInstanceDecalBias;
    vec3 g_xWindDirection;
    float g_fWindStrength;
    vec3 g_xSubsurfaceScatteringWeight;
    float g_fGlobalSamplerBias;
    vec3 g_xDeformationWindowCentre;
    float g_fDeformationWindowSize;
    float g_fDeformationUVDensity;
    float g_fDeformationNormalIntensity;
    float g_fRainfallIntensity;
    float g_fRainBaseWetness;
    vec3 g_xRainDirection;
} FrameConstants;

layout(set = 4, binding = 48, scalar) readonly buffer type_StructuredBuffer_StaticMaterial
{
    StaticMaterial _m0[];
} g_axMaterials;

layout(set = 1, binding = 1, scalar) uniform type_Material1Constants
{
    StaticMaterial g_xStaticMaterial1;
} Material1Constants;

layout(set = 1, binding = 2, scalar) uniform type_Material2Constants
{
    StaticMaterial g_xStaticMaterial2;
} Material2Constants;

layout(set = 2, binding = 12, std140) uniform type_SkinEffectParams
{
    vec3 g_xNoiseTextureOffset;
    float g_fNoiseValueOffset;
    vec4 g_xPlane;
    vec3 g_xTransitionColour;
    float g_fTransitionRoughness;
    vec3 g_xNoiseTextureScale;
    float g_fInvTransitionColourScale;
    float g_fCurrentTime;
    uint g_bDrawTransition;
    uint g_bDrawTransitionRoughness;
} SkinEffectParams;

layout(set = 0, binding = 6) uniform sampler g_xFilteredWrap;
layout(set = 0, binding = 7) uniform sampler g_xFilteredClamp;
layout(set = 3, binding = 0) 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
uniform texture2D g_xTextureArray[];
layout(set = 2, binding = 50) uniform TEXTURE_2D g_xSceneTexture;
layout(set = 2, binding = 80) uniform TEXTURE_2D g_xNoiseTexture;

layout(location = 0) in vec3 in_var_TANGENT;
layout(location = 1) in vec3 in_var_BINORMAL;
layout(location = 2) in vec3 in_var_NORMAL;
layout(location = 3) in vec4 in_var_TEXCOORD0;
layout(location = 4) in vec4 in_var_TEXCOORD1;
layout(location = 5) in vec3 in_var_TEXCOORD2;
layout(location = 0) out vec4 out_var_SV_TARGET;

vec3 _146;

void main()
{
    vec3 _162 = normalize(in_var_NORMAL);
    mat3 _163 = mat3(normalize(in_var_TANGENT), normalize(in_var_BINORMAL), _162);
    vec3 _165 = normalize(in_var_TEXCOORD1.xyz);
    vec3 _169 = in_var_TEXCOORD2 * SkinEffectParams.g_xNoiseTextureScale;
    vec4 _178 = SAMPLE_TEXTURE(SAMPLER_2D(g_xNoiseTexture, g_xFilteredWrap), _169.xy + SkinEffectParams.g_xNoiseTextureOffset.xx);
    vec4 _184 = SAMPLE_TEXTURE(SAMPLER_2D(g_xNoiseTexture, g_xFilteredWrap), _169.yz + SkinEffectParams.g_xNoiseTextureOffset.yy);
    vec4 _190 = SAMPLE_TEXTURE(SAMPLER_2D(g_xNoiseTexture, g_xFilteredWrap), _169.zx + SkinEffectParams.g_xNoiseTextureOffset.zz);
    float _198 = ((dot(vec3(_178.x, _184.y, _190.z), vec3(0.333000004291534423828125)) * 2.0) - 1.0) + SkinEffectParams.g_fNoiseValueOffset;
    float _205 = pow(1.0 - min(abs(_198) * SkinEffectParams.g_fInvTransitionColourScale, 1.0), 5.0);
    vec4 _215 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uTransparencyMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias);
    vec4 _223 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uDamageThresholdMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias);
    float _231 = 1.0 - (smoothstep(0.0, 0.100000001490116119384765625, ((g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseDamageThresholdMap != 0u) ? _223.x : 1.0) - ((in_var_TEXCOORD1.w - 0.100000001490116119384765625) * 1.10000002384185791015625)) * ((g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseTransparencyMap != 0u) ? _215.w : 1.0));
    vec4 _454;
    if ((g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u) || (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u))
    {
        vec4 _453;
        if (((g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u) && (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseBinarySearchForParallax != 0u)) || ((g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u) && (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseBinarySearchForParallax != 0u)))
        {
            vec3 _374 = normalize((-_165) / vec3(_165.z));
            _374.z = 1.0;
            vec3 _376;
            vec4 _381;
            _376 = _374;
            _381 = in_var_TEXCOORD0.xyxy;
            vec3 _377;
            float _380;
            vec4 _382;
            float _379 = 0.0;
            int _383 = 0;
            for (; _383 < 12; _376 = _377, _379 = _380, _381 = _382, _383++)
            {
                float _413;
                if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u)
                {
                    _413 = ((1.0 - 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uParallaxMap)], g_xFilteredWrap)), (_381.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x) * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxScale) + g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxBias;
                }
                else
                {
                    _413 = 0.0;
                }
                float _439;
                if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u)
                {
                    _439 = ((1.0 - 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uParallaxMap)], g_xFilteredWrap)), (_381.zw * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x) * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fParallaxScale) + g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fParallaxBias;
                }
                else
                {
                    _439 = 0.0;
                }
                _377 = _376 * 0.5;
                if (_379 < mix(_439, _413, _231))
                {
                    _380 = _379 + _377.z;
                    _382 = _381 + _377.xyxy;
                }
                else
                {
                    _380 = _379 - _377.z;
                    _382 = _381 - _377.xyxy;
                }
            }
            _453 = _381;
        }
        else
        {
            float _280;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u)
            {
                _280 = (
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uParallaxMap)], g_xFilteredWrap)), (in_var_TEXCOORD0.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxScale) + g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxBias;
            }
            else
            {
                _280 = 0.0;
            }
            float _304;
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u)
            {
                _304 = (
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uParallaxMap)], g_xFilteredWrap)), (in_var_TEXCOORD0.xy * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fParallaxScale) + g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fParallaxBias;
            }
            else
            {
                _304 = 0.0;
            }
            float _305 = mix(_304, _280, _231);
            vec2 _307 = _165.xy * _305;
            vec4 _309 = in_var_TEXCOORD0.xyxy + _307.xyxy;
            float _334;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u)
            {
                _334 = (
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uParallaxMap)], g_xFilteredWrap)), (_309.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxScale) + g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxBias;
            }
            else
            {
                _334 = 0.0;
            }
            float _359;
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u)
            {
                _359 = (
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uParallaxMap)], g_xFilteredWrap)), (_309.zw * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fParallaxScale) + g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fParallaxBias;
            }
            else
            {
                _359 = 0.0;
            }
            _453 = in_var_TEXCOORD0.xyxy + (_307 * clamp((-_305) / (mix(_359, _334, _231) - (2.0 * _305)), 0.0, 1.0)).xyxy;
        }
        _454 = _453;
    }
    else
    {
        _454 = in_var_TEXCOORD0.xyxy;
    }
    vec3 _547;
    do
    {
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseNormalMap != 0u)
        {
            vec4 _466 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uNormalMap)], g_xFilteredWrap)), _454.xy, 0.5);
            vec2 _469 = (_466.xy * 2.0) - vec2(1.0);
            vec3 _491;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseNormalDetailMap != 0u)
            {
                vec2 _489 = _469.xy + (((
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uNormalDetailMap)], g_xFilteredWrap)), _454.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fNormalDetailUVScale, 0.5).xy * 2.0) - vec2(1.0)) * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fNormalDetailValueScale);
                _491 = vec3(_489.x, _489.y, _146.z);
            }
            else
            {
                _491 = vec3(_469.x, _469.y, _146.z);
            }
            vec3 _494 = _491;
            _494.y = -_491.y;
            vec3 _499 = _494;
            _499.z = sqrt(1.0 - dot(_494.xy, _494.xy));
            vec3 _500 = _163 * _499;
            vec3 _545;
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseNormalMap != 0u)
            {
                vec4 _509 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uNormalMap)], g_xFilteredWrap)), _454.zw, 0.5);
                vec3 _512 = (_509.xyy * 2.0) - vec3(1.0);
                vec3 _533;
                if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseNormalDetailMap != 0u)
                {
                    vec2 _531 = _512.xy + (((
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uNormalDetailMap)], g_xFilteredWrap)), _454.zw * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fNormalDetailUVScale, 0.5).xy * 2.0) - vec2(1.0)) * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fNormalDetailValueScale);
                    _533 = vec3(_531.x, _531.y, _512.z);
                }
                else
                {
                    _533 = _512;
                }
                vec3 _536 = _533;
                _536.y = -_533.y;
                vec3 _541 = _536;
                _541.z = sqrt(1.0 - dot(_536.xy, _536.xy));
                _545 = mix(_163 * _541, _500, vec3(_231));
            }
            else
            {
                _545 = _500;
            }
            _547 = normalize(_545);
            break;
        }
        else
        {
            _547 = _162;
            break;
        }
    } while(false);
    vec4 _566 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
SAMPLE_TEXTURE(SAMPLER_2D(g_xSceneTexture, g_xFilteredClamp), (gl_FragCoord.xy + vec2(10.0 * sin((3.0 * dot(_547, _163 * _165)) + (8.0 * SkinEffectParams.g_fCurrentTime)))) * FrameConstants.g_xRcpScreenDims);
    vec4 _570 = vec4(_566.xyz, 1.0);
    vec4 _582;
    if (SkinEffectParams.g_bDrawTransition != 0u)
    {
        vec3 _580 = _570.xyz + (SkinEffectParams.g_xTransitionColour * _205);
        _582 = vec4(_580.x, _580.y, _580.z, _570.w);
    }
    else
    {
        _582 = _570;
    }
    if ((_198 < 0.0) && ((_205 < 9.9999997473787516355514526367188e-05) && true))
    {
        discard;
    }
    float _612;
    do
    {
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseTransparencyMap != 0u)
        {
            vec4 _600 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uTransparencyMap)], g_xFilteredWrap)), _454.xy, FrameConstants.g_fGlobalSamplerBias);
            float _601 = _600.w;
            float _611;
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseTransparencyMap != 0u)
            {
                _611 = mix(
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uTransparencyMap)], g_xFilteredWrap)), _454.zw, FrameConstants.g_fGlobalSamplerBias).w, _601, _231);
            }
            else
            {
                _611 = _601;
            }
            _612 = _611;
            break;
        }
        else
        {
            _612 = 1.0;
            break;
        }
    } while(false);
    vec4 _615 = _582;
    _615.w = _582.w * _612;
    out_var_SV_TARGET = _615;
}

