
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    float g_fBiasFactor;
    float g_fNearClip;
    float g_fFarClip;
};

layout(set = 3, binding = 9, std140) uniform type_UnpackConstants
{
    vec4 g_xScalingFactors;
    vec4 g_xOffsets;
} UnpackConstants;

layout(set = 3, binding = 10, std140) uniform type_InstancedConstants
{
    uint g_uInstancedAnimID;
} InstancedConstants;

layout(set = 2, binding = 7, std140) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 3, binding = 80, std430) readonly buffer type_StructuredBuffer_v4float
{
    vec4 _m0[];
} g_xInstanceTexture;

layout(location = 0) in vec4 in_var_POSITION;
layout(location = 1) in vec3 in_var_TANGENT;
layout(location = 2) in vec3 in_var_BINORMAL;
layout(location = 3) in vec3 in_var_NORMAL;
layout(location = 4) in vec3 in_var_TESSNORMAL;
layout(location = 5) in vec4 in_var_TEXCOORD;
layout(location = 6) in vec4 in_var_BLENDWEIGHTS0;
layout(location = 7) in vec4 in_var_BLENDWEIGHTS1;
layout(location = 8) in uvec4 in_var_BLENDINDICES0;
layout(location = 9) in uvec4 in_var_BLENDINDICES1;

void main()
{
    uvec4 _69 = in_var_BLENDINDICES0;
    uvec4 _70 = in_var_BLENDINDICES1;
    vec4 _71 = in_var_BLENDWEIGHTS0;
    vec4 _72 = in_var_BLENDWEIGHTS1;
    uint _93 = InstancedConstants.g_uInstancedAnimID + (_69.x * 3u);
    mat3x4 _68 = mat3x4(g_xInstanceTexture._m0[_93 + 8u], g_xInstanceTexture._m0[_93 + 9u], g_xInstanceTexture._m0[_93 + 10u]);
    _68[2].z = (_68[0u].x * _68[1u].y) - (_68[0u].y * _68[1u].x);
    mat3x4 _121;
    _121 = _68 * _71.x;
    mat3x4 _122;
    for (int _124 = 1; _124 < 4; _121 = _122, _124++)
    {
        uint _129 = uint(_124);
        if (_71[_129] == 0.0)
        {
            break;
        }
        uint _138 = InstancedConstants.g_uInstancedAnimID + (_69[_129] * 3u);
        mat3x4 _67 = mat3x4(g_xInstanceTexture._m0[_138 + 8u], g_xInstanceTexture._m0[_138 + 9u], g_xInstanceTexture._m0[_138 + 10u]);
        _67[2].z = (_67[0u].x * _67[1u].y) - (_67[0u].y * _67[1u].x);
        mat3x4 _162 = _67 * _71[_129];
        _122 = mat3x4(_121[0] + _162[0], _121[1] + _162[1], _121[2] + _162[2]);
    }
    mat3x4 _173;
    _173 = _121;
    mat3x4 _174;
    for (int _176 = 0; _176 < 4; _173 = _174, _176++)
    {
        uint _181 = uint(_176);
        if (_72[_181] == 0.0)
        {
            break;
        }
        uint _190 = InstancedConstants.g_uInstancedAnimID + (_70[_181] * 3u);
        mat3x4 _66 = mat3x4(g_xInstanceTexture._m0[_190 + 8u], g_xInstanceTexture._m0[_190 + 9u], g_xInstanceTexture._m0[_190 + 10u]);
        _66[2].z = (_66[0u].x * _66[1u].y) - (_66[0u].y * _66[1u].x);
        mat3x4 _214 = _66 * _72[_181];
        _174 = mat3x4(_173[0] + _214[0], _173[1] + _214[1], _173[2] + _214[2]);
    }
    gl_Position = vec4(vec4(vec4((in_var_POSITION.xyz * UnpackConstants.g_xScalingFactors.xyz) + UnpackConstants.g_xOffsets.xyz, 1.0) * _173, 1.0) * mat3x4(g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 5u], g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 6u], g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 7u]), 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
}

