
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    float g_fBiasFactor;
    float g_fNearClip;
    float g_fFarClip;
};

layout(set = 3, binding = 9, std140) uniform type_UnpackConstants
{
    vec4 g_xScalingFactors;
    vec4 g_xOffsets;
} UnpackConstants;

layout(set = 2, binding = 7, std140) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 1, binding = 8, std140) uniform type_AnimUVConstsShadow
{
    vec4 g_xUV_Offsets_Shadow;
} AnimUVConstsShadow;

layout(set = 4, binding = 80, std430) readonly buffer type_StructuredBuffer_v4float
{
    vec4 _m0[];
} g_xInstanceTexture;

layout(location = 0) in vec4 in_var_POSITION;
layout(location = 1) in vec3 in_var_TANGENT;
layout(location = 2) in vec3 in_var_BINORMAL;
layout(location = 3) in vec3 in_var_NORMAL;
layout(location = 4) in vec3 in_var_TESSNORMAL;
layout(location = 5) in vec4 in_var_TEXCOORD;
layout(location = 6) in vec4 in_var_BLENDWEIGHTS0;
layout(location = 7) in vec4 in_var_BLENDWEIGHTS1;
layout(location = 8) in uvec4 in_var_BLENDINDICES0;
layout(location = 9) in uvec4 in_var_BLENDINDICES1;
layout(location = 10) in uint in_var_BLENDINDICES2;
layout(location = 0) out vec2 out_var_TEXCOORD0;

void main()
{
    uvec4 _73 = in_var_BLENDINDICES0;
    uvec4 _74 = in_var_BLENDINDICES1;
    vec4 _75 = in_var_BLENDWEIGHTS0;
    vec4 _76 = in_var_BLENDWEIGHTS1;
    uint _97 = in_var_BLENDINDICES2 + (_73.x * 3u);
    mat3x4 _72 = mat3x4(g_xInstanceTexture._m0[_97 + 8u], g_xInstanceTexture._m0[_97 + 9u], g_xInstanceTexture._m0[_97 + 10u]);
    _72[2].z = (_72[0u].x * _72[1u].y) - (_72[0u].y * _72[1u].x);
    mat3x4 _125;
    _125 = _72 * _75.x;
    mat3x4 _126;
    for (int _128 = 1; _128 < 4; _125 = _126, _128++)
    {
        uint _133 = uint(_128);
        if (_75[_133] == 0.0)
        {
            break;
        }
        uint _142 = in_var_BLENDINDICES2 + (_73[_133] * 3u);
        mat3x4 _71 = mat3x4(g_xInstanceTexture._m0[_142 + 8u], g_xInstanceTexture._m0[_142 + 9u], g_xInstanceTexture._m0[_142 + 10u]);
        _71[2].z = (_71[0u].x * _71[1u].y) - (_71[0u].y * _71[1u].x);
        mat3x4 _166 = _71 * _75[_133];
        _126 = mat3x4(_125[0] + _166[0], _125[1] + _166[1], _125[2] + _166[2]);
    }
    mat3x4 _177;
    _177 = _125;
    mat3x4 _178;
    for (int _180 = 0; _180 < 4; _177 = _178, _180++)
    {
        uint _185 = uint(_180);
        if (_76[_185] == 0.0)
        {
            break;
        }
        uint _194 = in_var_BLENDINDICES2 + (_74[_185] * 3u);
        mat3x4 _70 = mat3x4(g_xInstanceTexture._m0[_194 + 8u], g_xInstanceTexture._m0[_194 + 9u], g_xInstanceTexture._m0[_194 + 10u]);
        _70[2].z = (_70[0u].x * _70[1u].y) - (_70[0u].y * _70[1u].x);
        mat3x4 _218 = _70 * _76[_185];
        _178 = mat3x4(_177[0] + _218[0], _177[1] + _218[1], _177[2] + _218[2]);
    }
    gl_Position = vec4(vec4(vec4((in_var_POSITION.xyz * UnpackConstants.g_xScalingFactors.xyz) + UnpackConstants.g_xOffsets.xyz, 1.0) * _177, 1.0) * mat3x4(g_xInstanceTexture._m0[in_var_BLENDINDICES2 + 5u], g_xInstanceTexture._m0[in_var_BLENDINDICES2 + 6u], g_xInstanceTexture._m0[in_var_BLENDINDICES2 + 7u]), 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
    out_var_TEXCOORD0 = in_var_TEXCOORD.xy + AnimUVConstsShadow.g_xUV_Offsets_Shadow.xy;
}

