// Shadows 3
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    uvec3 g_xPad;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 7, scalar) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 1, binding = 8, std140) uniform type_AnimUVConstsShadow
{
    vec4 g_xUV_Offsets_Shadow;
} AnimUVConstsShadow;

layout(location = 0) in vec4 in_var_POSITION0;
layout(location = 1) in vec4 in_var_COLOR0;
layout(location = 2) in vec3 in_var_NORMAL0;
layout(location = 3) in vec3 in_var_TANGENT0;
layout(location = 4) in vec3 in_var_BINORMAL0;
layout(location = 5) in vec3 in_var_TANGENT1;
layout(location = 6) in vec3 in_var_BINORMAL1;
layout(location = 7) in vec3 in_var_NORMAL1;
layout(location = 8) in vec4 in_var_TEXCOORD0;
layout(location = 9) in vec2 in_var_TEXCOORD1;
layout(location = 0) out vec2 out_var_TEXCOORD0;

void main()
{
    gl_Position = in_var_POSITION0 * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
//gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y);
    out_var_TEXCOORD0 = in_var_TEXCOORD0.xy + AnimUVConstsShadow.g_xUV_Offsets_Shadow.xy;
//gl_Position.x = 0;
}



