// Minimap things - BREAKS minimap if UI is pushed to DEPTH!
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_scalar_block_layout : require


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 1, scalar) uniform type_QuadConstants
{
    uint g_bUseTexture;
    uint g_bUseRadialClip;
    float g_fClipStartRadius;
    float g_fClipEndRadius;
    float g_fInnerClipStartRadius;
    float g_fInnerClipEndRadius;
    vec2 g_xClipCentre;
    uint g_bUseWrapSampler;
    uint g_bUsePointMag;
    uint g_bUseDF;
    uint g_bUseTextureAlphaMask;
    vec2 g_xAlphaMaskOrigin;
    vec2 g_xOneOverAlphaMaskDimensions;
    vec4 g_xAlphaMaskUVs;
    vec4 g_xOutlineColour;
    vec4 g_xOuterGlowColour;
    vec2 g_fTextureSize;
    float g_fOuterGlowMin;
    float g_fOuterGlowMax;
    float g_fOutlineHalfThickness;
    float g_fOutlineOffset;
    float g_fAntiAliasDistance;
    float g_fInnerAlpha;
    float g_fTolerance;
    uint g_bOutline;
    uint g_bAntiAlias;
    uint g_bOuterGlow;
    vec2 g_xAlphaMaskRotation;
    uint g_bUseMSDF;
    int g_iBlendOperation;
    float g_fBlendLerp;
    vec2 g_xBlendUVOffset;
} QuadConstants;

layout(set = 0, binding = 3) uniform sampler g_xBilinearClamp;
layout(set = 0, binding = 4) uniform sampler g_xTrilinearWrap;
layout(set = 0, binding = 5) uniform sampler g_xTrilinearClamp;
layout(set = 0, binding = 10) uniform sampler g_xPointMagWrap;
layout(set = 0, binding = 11) uniform sampler g_xPointMagClamp;
layout(set = 1, binding = 48) uniform TEXTURE_2D g_xTexture;
layout(set = 1, binding = 49) uniform TEXTURE_2D g_xMaskTexture;

layout(location = 0) in vec2 in_var_TEXCOORD0;
layout(location = 1) in vec4 in_var_COLOR0;
layout(location = 0) out vec4 out_var_SV_Target;

vec2 _73;
vec2 _74;

void main()
{
    vec4 _303;
    if (QuadConstants.g_bUseDF != 0u)
    {
        vec2 _206 = dFdx(in_var_TEXCOORD0 * QuadConstants.g_fTextureSize);
        vec4 _214 = QuadConstants.g_xOuterGlowColour * in_var_COLOR0.w;
        float _240;
        float _241;
        if (QuadConstants.g_bUseMSDF != 0u)
        {
            vec4 _231 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearWrap), in_var_TEXCOORD0);
            float _232 = _231.x;
            float _233 = _231.y;
            _240 = _231.w;
            _241 = max(min(_232, _233), min(max(_232, _233), _231.z));
        }
        else
        {
            vec4 _226 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearWrap), in_var_TEXCOORD0);
            float _227 = _226.x;
            _240 = _227;
            _241 = _227;
        }
        float _245 = clamp(QuadConstants.g_fAntiAliasDistance * length(_206), 0.0, 1.0);
        float _259;
        if (QuadConstants.g_bAntiAlias != 0u)
        {
            _259 = smoothstep(clamp(QuadConstants.g_fTolerance - _245, 0.0, 1.0), clamp(QuadConstants.g_fTolerance + _245, 0.0, 1.0), _241);
        }
        else
        {
            _259 = float(_241 >= QuadConstants.g_fTolerance);
        }
        vec4 _281;
        if (QuadConstants.g_bOuterGlow != 0u)
        {
            vec4 _275 = _214;
            _275.w = _214.w * smoothstep(QuadConstants.g_fOuterGlowMin, QuadConstants.g_fOuterGlowMax, _240);
            _281 = mix(_275, in_var_COLOR0 * QuadConstants.g_fInnerAlpha, vec4(_259));
        }
        else
        {
            vec4 _267 = in_var_COLOR0;
            _267.w = in_var_COLOR0.w * _259;
            _281 = _267;
        }
        vec4 _302;
        if (QuadConstants.g_bOutline != 0u)
        {
            float _289 = QuadConstants.g_fTolerance + QuadConstants.g_fOutlineOffset;
            float _292 = _289 + QuadConstants.g_fOutlineHalfThickness;
            float _293 = _289 - QuadConstants.g_fOutlineHalfThickness;
            _302 = mix(_281, QuadConstants.g_xOutlineColour * in_var_COLOR0.w, vec4((smoothstep(_293, _293 + _245, _241) + smoothstep(_292, _292 - _245, _241)) - 1.0));
        }
        else
        {
            _302 = _281;
        }
        _303 = _302;
    }
    else
    {
        vec4 _202;
        if (QuadConstants.g_bUseTexture != 0u)
        {
            vec4 _201;
            if (QuadConstants.g_fBlendLerp > 0.0)
            {
                bool _136;
                vec4 _164;
                do
                {
                    _136 = QuadConstants.g_bUsePointMag != 0u;
                    if (_136)
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _164 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagWrap), in_var_TEXCOORD0);
                            break;
                        }
                        else
                        {
                            _164 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagClamp), in_var_TEXCOORD0);
                            break;
                        }
                    }
                    else
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _164 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearWrap), in_var_TEXCOORD0);
                            break;
                        }
                        else
                        {
                            _164 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearClamp), in_var_TEXCOORD0);
                            break;
                        }
                    }
                } while(false);
                vec2 _167 = in_var_TEXCOORD0 + QuadConstants.g_xBlendUVOffset;
                vec4 _197;
                do
                {
                    if (_136)
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _197 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagWrap), _167);
                            break;
                        }
                        else
                        {
                            _197 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagClamp), _167);
                            break;
                        }
                    }
                    else
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _197 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearWrap), _167);
                            break;
                        }
                        else
                        {
                            _197 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearClamp), _167);
                            break;
                        }
                    }
                } while(false);
                _201 = in_var_COLOR0 * mix(_164, _197, vec4(QuadConstants.g_fBlendLerp));
            }
            else
            {
                vec4 _129;
                do
                {
                    if (QuadConstants.g_bUsePointMag != 0u)
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _129 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagWrap), in_var_TEXCOORD0);
                            break;
                        }
                        else
                        {
                            _129 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xPointMagClamp), in_var_TEXCOORD0);
                            break;
                        }
                    }
                    else
                    {
                        if (QuadConstants.g_bUseWrapSampler != 0u)
                        {
                            _129 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearWrap), in_var_TEXCOORD0);
                            break;
                        }
                        else
                        {
                            _129 = SAMPLE_TEXTURE(SAMPLER_2D(g_xTexture, g_xTrilinearClamp), in_var_TEXCOORD0);
                            break;
                        }
                    }
                } while(false);
                _201 = in_var_COLOR0 * _129;
            }
            _202 = _201;
        }
        else
        {
            _202 = in_var_COLOR0;
        }
        _303 = _202;
    }
    vec4 _341= vec4(1);
    if (QuadConstants.g_bUseRadialClip != 0u)
    {
        float _313 = length(gl_FragCoord.xy - QuadConstants.g_xClipCentre);
        float _337;
        if (_313 < QuadConstants.g_fInnerClipEndRadius)
        {
            _337 = clamp((_313 - QuadConstants.g_fInnerClipStartRadius) / max(QuadConstants.g_fInnerClipEndRadius - QuadConstants.g_fInnerClipStartRadius, 0.00999999977648258209228515625), 0.0, 1.0)*2;
        }
        else
        {
            _337 = 1.0 - clamp((_313 - QuadConstants.g_fClipStartRadius) / max(QuadConstants.g_fClipEndRadius - QuadConstants.g_fClipStartRadius, 0.00999999977648258209228515625), 0.0, 1.0)*2;
        }
        vec4 _340 = _303;
        _340.w = _303.w * _337;
        _341 = _340;
    }
    else
    {
        _341 = _303;
    }
    vec4 _404;
    if (QuadConstants.g_bUseTextureAlphaMask != 0u)
    {
        vec2 _350 = gl_FragCoord.xy - QuadConstants.g_xAlphaMaskOrigin;
        float _351 = _350.x;
        float _355 = _350.y;
        vec2 _360 = _74;
        _360.x = (_351 * QuadConstants.g_xAlphaMaskRotation.x) + (_355 * QuadConstants.g_xAlphaMaskRotation.y);
        vec2 _364 = _360;
        _364.y = (_355 * QuadConstants.g_xAlphaMaskRotation.x) - (_351 * QuadConstants.g_xAlphaMaskRotation.y);
        vec2 _367 = _364 * QuadConstants.g_xOneOverAlphaMaskDimensions;
        float _368 = _367.x;
        if ((_368 < 0.0) || (_368 > 1.0))
        {
            discard;
        }
        float _374 = _367.y;
        if ((_374 < 0.0) || (_374 > 1.0))
        {
            discard;
        }
        vec2 _387 = _73;
        _387.x = QuadConstants.g_xAlphaMaskUVs.x + (_368 * (QuadConstants.g_xAlphaMaskUVs.z - QuadConstants.g_xAlphaMaskUVs.x));
        vec2 _395 = _387;
        _395.y = QuadConstants.g_xAlphaMaskUVs.y + (_374 * (QuadConstants.g_xAlphaMaskUVs.w - QuadConstants.g_xAlphaMaskUVs.y));
        vec4 _403 = _341;
        _403.w = _341.w * SAMPLE_TEXTURE(SAMPLER_2D(g_xMaskTexture, g_xBilinearClamp), _395).x;
        _404 = _403;
    }
    else
    {
        _404 = _341;
    }
    out_var_SV_Target = vec4(_404.xyz * _404.w, 1.0);
    
//    if (vk3d_params[VIEW].custom_params.x != 0)
//	    out_var_SV_Target = vec4(0);
}
