//XRAY 2 - Shadows

#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 4, binding = 0, scalar) uniform type_FrameConstants
{
    layout(row_major) mat4 g_xView;
    layout(row_major) mat4 g_xProj;
    layout(row_major) mat4 g_xViewProj;
    layout(row_major) mat4 g_xInvView;
    layout(row_major) mat4 g_xInvProj;
    layout(row_major) mat4 g_xInvViewProj;
    vec3 g_xCamPos;
    float g_fScaledTime;
    vec4 g_xTwoOverScreenDimensions;
    vec2 g_xCameraTanHalfFOV;
    vec2 g_xCameraFarClipValues;
    vec2 g_xRcpScreenDims;
    vec2 g_xDepthProjViewUnpack;
    vec4 g_axViewFrustumPlanes[6];
    ivec4 g_xScreenDimensions;
    vec4 g_xTessCutoffAndFactors;
    float g_fTessMaxDist;
    float g_fTessRcpRange;
    float g_fDisplacementScale;
    float g_fBackFaceCutoff;
    float g_fFoliageFadeInvDistance;
    float g_fFoliageFadePower;
    uint g_bFoliageFadeEnabled;
    float g_fEnvironmentDecalBias;
    float g_fInstanceDecalBias;
    vec3 g_xWindDirection;
    float g_fWindStrength;
    vec3 g_xSubsurfaceScatteringWeight;
    float g_fGlobalSamplerBias;
    vec3 g_xDeformationWindowCentre;
    float g_fDeformationWindowSize;
    float g_fDeformationUVDensity;
    float g_fDeformationNormalIntensity;
    float g_fRainfallIntensity;
    float g_fRainBaseWetness;
    vec3 g_xRainDirection;
} FrameConstants;

layout(set = 1, binding = 4, std140) uniform type_Asura_XRaySkin_ControlConstants
{
    uint g_bUseExternalRT;
    uint g_bOnlyUseExternalRT;
    uint g_bUseShadow;
} Asura_XRaySkin_ControlConstants;

layout(set = 1, binding = 12, std140) uniform type_CapsulePSConstants
{
    vec3 g_x3DCapsuleEndPos1;
    float g_x3DCapsuleRadius1;
    vec3 g_x3DCapsuleEndPos2;
    float g_x3DCapsuleRadius2;
    vec3 g_xCapsuleProjectionVector;
    float g_fProjectionRadius;
    vec3 g_xCapsuleProjectionUVector;
    float g_fSkinOutlineExtrudeDistance;
    vec3 g_xCapsuleProjectionVVector;
    float g_fPad;
    float g_fCutoutTexture1Influence;
    float g_fCutoutTexture2Influence;
    float g_fProjectionRadiusLerpToCapsuleRadius;
    uint g_uNumNoiseOctaves;
    vec4 g_auNoiseParameters[10];
    float g_fNoiseAlphaStart;
    float g_fNoiseAlphaPeak;
    float g_fNoiseAlphaEnd;
    float g_fInvNoiseFeather;
    vec4 g_xCutOutTextureUVTransform1[3];
    vec4 g_xCutOutTextureUVTransform2[3];
    vec2 g_x2DCapsuleEndPos1;
    vec2 g_x2DCapsuleEndPos2;
    float g_fConeOffset1;
    float g_fSphereRadius1;
    float g_fConeOffset2;
    float g_fSphereRadius2;
    vec2 g_x2DCapsuleVec;
    vec2 g_x2DCapsuleVecNormalised;
    float g_f2DCapsuleVecLength;
    float g_fCosTheta;
    float g_fInvCosTheta;
    float g_fInvTanTheta;
    vec4 g_xFadeParams;
    vec4 g_xCameraTanHalfFOV2;
    vec4 g_xSphereColour;
    uint g_bApplyNoiseToCapsulePass;
    uint g_bApplyNoiseToSkinPass;
    uint g_b3DCapsuleInCapsulePass;
    uint g_b3DCapsuleInSkinPass;
} CapsulePSConstants;

layout(set = 0, binding = 6) uniform sampler g_xFilteredWrap;
layout(set = 0, binding = 7) uniform sampler g_xFilteredClamp;
layout(set = 1, binding = 86) uniform TEXTURE_2D g_xCutoutTexture1;
layout(set = 1, binding = 87) uniform TEXTURE_2D g_xCutoutTexture2;
layout(set = 1, binding = 99) uniform TEXTURE_2D g_xScreenAlpha;

layout(location = 0) in vec3 in_var_NORMAL;
layout(location = 1) in vec4 in_var_TEXCOORD1;
layout(location = 0) out vec4 out_var_SV_TARGET;

vec4 _129;

void main()
{
    float _139 = FrameConstants.g_xDepthProjViewUnpack.x / (FrameConstants.g_xDepthProjViewUnpack.y - gl_FragCoord.z);
    //vec4 _156 = vec4((FrameConstants.g_xCameraTanHalfFOV * _139) * (((gl_FragCoord.xy + FrameConstants.g_xTwoOverScreenDimensions.zw) * FrameConstants.g_xTwoOverScreenDimensions.xy) - vec2(1.0)), _139, 1.0) * FrameConstants.g_xInvView;
    vec4 _156 = vec4((FrameConstants.g_xCameraTanHalfFOV * _139) * (((gl_FragCoord.xy + FrameConstants.g_xTwoOverScreenDimensions.zw) * FrameConstants.g_xTwoOverScreenDimensions.xy) - vec2(1.0)), _139, 1.0);
	_156.x -= vk3d_params[VIEW].stereo.x * (_139 - vk3d_params[VIEW].stereo.y) * FrameConstants.g_xInvProj[0][0];
    _156 = _156 *  FrameConstants.g_xInvView;
    
    vec3 _164 = vec3(((gl_FragCoord.xy * 2.0) * FrameConstants.g_xRcpScreenDims) - vec2(1.0), 0.0);
    float _752;
    float _753;
    if (CapsulePSConstants.g_b3DCapsuleInSkinPass != 0u)
    {
        vec3 _248 = _156.xyz;
        vec3 _255 = CapsulePSConstants.g_x3DCapsuleEndPos2 - CapsulePSConstants.g_x3DCapsuleEndPos1;
        float _256 = length(_255);
        vec3 _257 = _248 - CapsulePSConstants.g_x3DCapsuleEndPos1;
        vec2 _258 = _164.xy;
        vec2 _264 = vec2(1.0, CapsulePSConstants.g_xCameraTanHalfFOV2.z);
        vec2 _265 = (_258 - CapsulePSConstants.g_x2DCapsuleEndPos1) / _264;
        float _266 = length(_265);
        float _328;
        float _329;
        if (CapsulePSConstants.g_f2DCapsuleVecLength > 9.9999997473787516355514526367188e-05)
        {
            float _278 = dot(_265, CapsulePSConstants.g_x2DCapsuleVecNormalised);
            float _326;
            float _327;
            if ((_266 < 0.001000000047497451305389404296875) || ((_278 / _266) < CapsulePSConstants.g_fCosTheta))
            {
                _326 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius1;
                _327 = _266;
            }
            else
            {
                float _292 = length((_258 - CapsulePSConstants.g_x2DCapsuleEndPos2) / _264);
                float _321;
                float _322;
                if ((_292 < 0.001000000047497451305389404296875) || (((_278 - CapsulePSConstants.g_f2DCapsuleVecLength) / _292) > CapsulePSConstants.g_fCosTheta))
                {
                    _321 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius2;
                    _322 = _292;
                }
                else
                {
                    float _306 = length(_265 - (CapsulePSConstants.g_x2DCapsuleVecNormalised * _278)) * CapsulePSConstants.g_fInvTanTheta;
                    _321 = mix(CapsulePSConstants.g_fSphereRadius1, CapsulePSConstants.g_fSphereRadius2, (_278 - _306) / CapsulePSConstants.g_f2DCapsuleVecLength) * CapsulePSConstants.g_xFadeParams.w;
                    _322 = _306 * CapsulePSConstants.g_fInvCosTheta;
                }
                _326 = _321;
                _327 = _322;
            }
            _328 = _326;
            _329 = _327;
        }
        else
        {
            _328 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius1;
            _329 = _266;
        }
        float _332 = clamp(1.0 - (_329 / _328), 0.0, 1.0);
        float _750;
        float _751;
        if (_256 > 0.00999999977648258209228515625)
        {
            float _436 = dot(_257, _255 / vec3(_256));
            float _748;
            float _749;
            if (_436 < 0.0)
            {
                float _653 = CapsulePSConstants.g_x3DCapsuleRadius1 * CapsulePSConstants.g_xFadeParams.w;
                float _657 = clamp(1.0 - (length(_257) / _653), 0.0, 1.0);
                float _658 = min(_657, _332);
                bool _661 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
                bool _664 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
                float _747;
                if (_661 || _664)
                {
                    float _673 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, _653, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                    vec3 _678 = _257 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _257));
                    float _682 = dot(_678, CapsulePSConstants.g_xCapsuleProjectionUVector) * _673;
                    float _686 = dot(_678, CapsulePSConstants.g_xCapsuleProjectionVVector) * _673;
                    float _716;
                    if (_661)
                    {
                        _716 = mix(_658, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_682 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_686 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_682 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_686 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _658 * CapsulePSConstants.g_fCutoutTexture1Influence);
                    }
                    else
                    {
                        _716 = _658;
                    }
                    float _746;
                    if (_664)
                    {
                        _746 = mix(_716, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_682 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) + (_686 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_682 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_686 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _716 * CapsulePSConstants.g_fCutoutTexture2Influence);
                    }
                    else
                    {
                        _746 = _716;
                    }
                    _747 = _746;
                }
                else
                {
                    _747 = _658;
                }
                _748 = _657;
                _749 = _747;
            }
            else
            {
                float _649;
                float _650;
                if (_436 > _256)
                {
                    float _554 = CapsulePSConstants.g_x3DCapsuleRadius2 * CapsulePSConstants.g_xFadeParams.w;
                    float _558 = clamp(1.0 - (length(_257) / _554), 0.0, 1.0);
                    float _559 = min(_558, _332);
                    bool _562 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
                    bool _565 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
                    float _648;
                    if (_562 || _565)
                    {
                        float _574 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, _554, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                        vec3 _579 = _257 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _257));
                        float _583 = dot(_579, CapsulePSConstants.g_xCapsuleProjectionUVector) * _574;
                        float _587 = dot(_579, CapsulePSConstants.g_xCapsuleProjectionVVector) * _574;
                        float _617;
                        if (_562)
                        {
                            _617 = mix(_559, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_583 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_587 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_583 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_587 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _559 * CapsulePSConstants.g_fCutoutTexture1Influence);
                        }
                        else
                        {
                            _617 = _559;
                        }
                        float _647;
                        if (_565)
                        {
                            _647 = mix(_617, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_583 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) + (_587 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_583 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_587 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _617 * CapsulePSConstants.g_fCutoutTexture2Influence);
                        }
                        else
                        {
                            _647 = _617;
                        }
                        _648 = _647;
                    }
                    else
                    {
                        _648 = _559;
                    }
                    _649 = _558;
                    _650 = _648;
                }
                else
                {
                    float _446 = clamp(_436 / _256, 0.0, 1.0);
                    float _452 = CapsulePSConstants.g_xFadeParams.w * mix(CapsulePSConstants.g_x3DCapsuleRadius1, CapsulePSConstants.g_x3DCapsuleRadius2, _446);
                    vec3 _454 = _255 * (_446 * _256);
                    float _459 = clamp(1.0 - (length(_257 - _454) / _452), 0.0, 1.0);
                    float _460 = min(_459, _332);
                    vec3 _462 = _248 - (CapsulePSConstants.g_x3DCapsuleEndPos1 + _454);
                    bool _465 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
                    bool _468 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
                    float _551;
                    if (_465 || _468)
                    {
                        float _477 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, _452, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                        vec3 _482 = _462 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _462));
                        float _486 = dot(_482, CapsulePSConstants.g_xCapsuleProjectionUVector) * _477;
                        float _490 = dot(_482, CapsulePSConstants.g_xCapsuleProjectionVVector) * _477;
                        float _520;
                        if (_465)
                        {
                            _520 = mix(_460, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_486 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_490 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_486 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_490 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _460 * CapsulePSConstants.g_fCutoutTexture1Influence);
                        }
                        else
                        {
                            _520 = _460;
                        }
                        float _550;
                        if (_468)
                        {
                            _550 = mix(_520, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_486 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) + (_490 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_486 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_490 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _520 * CapsulePSConstants.g_fCutoutTexture2Influence);
                        }
                        else
                        {
                            _550 = _520;
                        }
                        _551 = _550;
                    }
                    else
                    {
                        _551 = _460;
                    }
                    _649 = _459;
                    _650 = _551;
                }
                _748 = _649;
                _749 = _650;
            }
            _750 = _748;
            _751 = _749;
        }
        else
        {
            float _339 = CapsulePSConstants.g_x3DCapsuleRadius1 * CapsulePSConstants.g_xFadeParams.w;
            float _343 = clamp(1.0 - (length(_257) / _339), 0.0, 1.0);
            float _344 = min(_343, _332);
            bool _347 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
            bool _350 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
            float _433;
            if (_347 || _350)
            {
                float _359 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, _339, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                vec3 _364 = _257 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _257));
                float _368 = dot(_364, CapsulePSConstants.g_xCapsuleProjectionUVector) * _359;
                float _372 = dot(_364, CapsulePSConstants.g_xCapsuleProjectionVVector) * _359;
                float _402;
                if (_347)
                {
                    _402 = mix(_344, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_368 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_372 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_368 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_372 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _344 * CapsulePSConstants.g_fCutoutTexture1Influence);
                }
                else
                {
                    _402 = _344;
                }
                float _432;
                if (_350)
                {
                    _432 = mix(_402, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_368 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) +
                     (_372 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_368 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_372 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) 
                     + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _402 * CapsulePSConstants.g_fCutoutTexture2Influence);
                }
                else
                {
                    //_432 = _402;
                }
                _433 = _432;
            }
            else
            {
                _433 = _344;
            }
            _750 = _343;
            _751 = _433;
        }
        _752 = _751;
        _753 = _750;
    }
    else
    {
        vec2 _173 = _164.xy;
        vec2 _179 = vec2(1.0, CapsulePSConstants.g_xCameraTanHalfFOV2.z);
        vec2 _180 = (_173 - CapsulePSConstants.g_x2DCapsuleEndPos1) / _179;
        float _181 = length(_180);
        float _243;
        float _244;
        if (CapsulePSConstants.g_f2DCapsuleVecLength > 9.9999997473787516355514526367188e-05)
        {
            float _193 = dot(_180, CapsulePSConstants.g_x2DCapsuleVecNormalised);
            float _241;
            float _242;
            if ((_181 < 0.001000000047497451305389404296875) || ((_193 / _181) < CapsulePSConstants.g_fCosTheta))
            {
                _241 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius1;
                _242 = _181;
            }
            else
            {
                float _207 = length((_173 - CapsulePSConstants.g_x2DCapsuleEndPos2) / _179);
                float _236;
                float _237;
                if ((_207 < 0.001000000047497451305389404296875) || (((_193 - CapsulePSConstants.g_f2DCapsuleVecLength) / _207) > CapsulePSConstants.g_fCosTheta))
                {
                    _236 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius2;
                    _237 = _207;
                }
                else
                {
                    float _221 = length(_180 - (CapsulePSConstants.g_x2DCapsuleVecNormalised * _193)) * CapsulePSConstants.g_fInvTanTheta;
                    _236 = mix(CapsulePSConstants.g_fSphereRadius1, CapsulePSConstants.g_fSphereRadius2, (_193 - _221) / CapsulePSConstants.g_f2DCapsuleVecLength) * CapsulePSConstants.g_xFadeParams.w;
                    _237 = _221 * CapsulePSConstants.g_fInvCosTheta;
                }
                _241 = _236;
                _242 = _237;
            }
            _243 = _241;
            _244 = _242;
        }
        else
        {
            _243 = CapsulePSConstants.g_xFadeParams.w * CapsulePSConstants.g_fSphereRadius1;
            _244 = _181;
        }
        float _247 = clamp(1.0 - (_244 / _243), 0.0, 1.0);
        _752 = _247;
        _753 = _247;
    }
    float _1131;
    if (CapsulePSConstants.g_bApplyNoiseToSkinPass != 0u)
    {
        float _1130;
        do
        {
            if (CapsulePSConstants.g_uNumNoiseOctaves == 0u)
            {
                _1130 = _752;
                break;
            }
            else
            {
                float _768;
                _768 = 0.0;
                for (uint _771 = 0u; _771 < CapsulePSConstants.g_uNumNoiseOctaves; )
                {
                    vec4 _784 = vec4(_156.xyz, FrameConstants.g_fScaledTime) * CapsulePSConstants.g_auNoiseParameters[_771].xxxy;
                    vec4 _788 = floor(_784 + vec4(dot(_784, vec4(0.309017002582550048828125))));
                    vec4 _792 = (_784 - _788) + vec4(dot(_788, vec4(0.13819660246372222900390625)));
                    vec3 _795 = step(_792.yzw, _792.xxx);
                    vec3 _798 = step(_792.zww, _792.yyz);
                    vec4 _804 = _129;
                    _804.x = (_795.x + _795.y) + _795.z;
                    vec3 _805 = vec3(1.0) - _795;
                    vec4 _812 = vec4(_804.x, _805.x, _805.y, _805.z);
                    _812.y = _805.x + (_798.x + _798.y);
                    vec2 _816 = _812.zw + (vec2(1.0) - _798.xy);
                    float _818 = _798.z;
                    vec4 _821 = vec4(_812.x, _812.y, _816.x, _816.y);
                    _821.z = _816.x + _818;
                    vec4 _825 = _821;
                    _825.w = _816.y + (1.0 - _818);
                    vec4 _826 = clamp(_825, vec4(0.0), vec4(1.0));
                    vec4 _828 = clamp(_825 - vec4(1.0), vec4(0.0), vec4(1.0));
                    vec4 _830 = clamp(_825 - vec4(2.0), vec4(0.0), vec4(1.0));
                    vec4 _832 = (_792 - _830) + vec4(0.13819660246372222900390625);
                    vec4 _834 = (_792 - _828) + vec4(0.2763932049274444580078125);
                    vec4 _836 = (_792 - _826) + vec4(0.4145897924900054931640625);
                    vec4 _837 = _792 + vec4(-0.447213590145111083984375);
                    vec4 _841 = _788 - (floor(_788 * 0.00346020772121846675872802734375) * 289.0);
                    float _842 = _841.w;
                    float _845 = ((_842 * _842) * 34.0) + _842;
                    float _850 = _841.z;
                    float _851 = (_845 - (floor(_845 * 0.00346020772121846675872802734375) * 289.0)) + _850;
                    float _854 = ((_851 * _851) * 34.0) + _851;
                    float _859 = _841.y;
                    float _860 = (_854 - (floor(_854 * 0.00346020772121846675872802734375) * 289.0)) + _859;
                    float _863 = ((_860 * _860) * 34.0) + _860;
                    float _868 = _841.x;
                    float _869 = (_863 - (floor(_863 * 0.00346020772121846675872802734375) * 289.0)) + _868;
                    float _872 = ((_869 * _869) * 34.0) + _869;
                    vec4 _882 = vec4(_842) + vec4(_830.w, _828.w, _826.w, 1.0);
                    vec4 _885 = ((_882 * _882) * 34.0) + _882;
                    vec4 _896 = ((_885 - (floor(_885 * 0.00346020772121846675872802734375) * 289.0)) + vec4(_850)) + vec4(_830.z, _828.z, _826.z, 1.0);
                    vec4 _899 = ((_896 * _896) * 34.0) + _896;
                    vec4 _910 = ((_899 - (floor(_899 * 0.00346020772121846675872802734375) * 289.0)) + vec4(_859)) + vec4(_830.y, _828.y, _826.y, 1.0);
                    vec4 _913 = ((_910 * _910) * 34.0) + _910;
                    vec4 _924 = ((_913 - (floor(_913 * 0.00346020772121846675872802734375) * 289.0)) + vec4(_868)) + vec4(_830.x, _828.x, _826.x, 1.0);
                    vec4 _927 = ((_924 * _924) * 34.0) + _924;
                    vec4 _931 = _927 - (floor(_927 * 0.00346020772121846675872802734375) * 289.0);
                    vec3 _937 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * (_872 - (floor(_872 * 0.00346020772121846675872802734375) * 289.0))) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                    float _942 = 1.5 - dot(abs(_937.xyz), vec3(1.0));
                    vec4 _943 = vec4(_937.x, _937.y, _937.z, _129.w);
                    _943.w = _942;
                    vec3 _952 = _943.xyz - vec3(ivec3(sign(_943.xyz)) * ivec3(int(_942 < 0.0)));
                    vec4 _953 = vec4(_952.x, _952.y, _952.z, _943.w);
                    vec3 _960 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _931.x) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                    float _965 = 1.5 - dot(abs(_960.xyz), vec3(1.0));
                    vec4 _966 = vec4(_960.x, _960.y, _960.z, _129.w);
                    _966.w = _965;
                    vec3 _975 = _966.xyz - vec3(ivec3(sign(_966.xyz)) * ivec3(int(_965 < 0.0)));
                    vec4 _976 = vec4(_975.x, _975.y, _975.z, _966.w);
                    vec3 _983 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _931.y) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                    float _988 = 1.5 - dot(abs(_983.xyz), vec3(1.0));
                    vec4 _989 = vec4(_983.x, _983.y, _983.z, _129.w);
                    _989.w = _988;
                    vec3 _998 = _989.xyz - vec3(ivec3(sign(_989.xyz)) * ivec3(int(_988 < 0.0)));
                    vec4 _999 = vec4(_998.x, _998.y, _998.z, _989.w);
                    vec3 _1006 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _931.z) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                    float _1011 = 1.5 - dot(abs(_1006.xyz), vec3(1.0));
                    vec4 _1012 = vec4(_1006.x, _1006.y, _1006.z, _129.w);
                    _1012.w = _1011;
                    vec3 _1021 = _1012.xyz - vec3(ivec3(sign(_1012.xyz)) * ivec3(int(_1011 < 0.0)));
                    vec4 _1022 = vec4(_1021.x, _1021.y, _1021.z, _1012.w);
                    vec3 _1029 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _931.w) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                    float _1034 = 1.5 - dot(abs(_1029.xyz), vec3(1.0));
                    vec4 _1035 = vec4(_1029.x, _1029.y, _1029.z, _129.w);
                    _1035.w = _1034;
                    vec3 _1044 = _1035.xyz - vec3(ivec3(sign(_1035.xyz)) * ivec3(int(_1034 < 0.0)));
                    vec4 _1045 = vec4(_1044.x, _1044.y, _1044.z, _1035.w);
                    vec4 _1051 = inversesqrt(vec4(dot(_953, _953), dot(_976, _976), dot(_999, _999), dot(_1022, _1022)));
                    vec3 _1068 = max(vec3(0.60000002384185791015625) - vec3(dot(_792, _792), dot(_832, _832), dot(_834, _834)), vec3(0.0));
                    vec2 _1073 = max(vec2(0.60000002384185791015625) - vec2(dot(_836, _836), dot(_837, _837)), vec2(0.0));
                    vec3 _1074 = _1068 * _1068;
                    vec2 _1075 = _1073 * _1073;
                    _768 += ((49.0 * (dot(_1074 * _1074, vec3(dot(_953 * _1051.x, _792), dot(_976 * _1051.y, _832), dot(_999 * _1051.z, _834))) + dot(_1075 * _1075, vec2(dot(_1022 * _1051.w, _836), dot(_1045 * inversesqrt(dot(_1045, _1045)), _837))))) * CapsulePSConstants.g_auNoiseParameters[_771].z);
                    _771++;
                    continue;
                }
                if (_753 <= CapsulePSConstants.g_fNoiseAlphaStart)
                {
                    _1130 = _752;
                    break;
                }
                if (_752 >= CapsulePSConstants.g_fNoiseAlphaEnd)
                {
                    _1130 = _752;
                    break;
                }
                float _1117;
                if (_752 < CapsulePSConstants.g_fNoiseAlphaPeak)
                {
                    _1117 = clamp((_752 - CapsulePSConstants.g_fNoiseAlphaStart) / (CapsulePSConstants.g_fNoiseAlphaPeak - CapsulePSConstants.g_fNoiseAlphaStart), 0.0, 1.0);
                }
                else
                {
                    _1117 = clamp(1.0 - ((_752 - CapsulePSConstants.g_fNoiseAlphaPeak) / (CapsulePSConstants.g_fNoiseAlphaEnd - CapsulePSConstants.g_fNoiseAlphaPeak)), 0.0, 1.0);
                }
                _1130 = mix(_752, (1.0 - clamp((((min(1.0, max(-1.0, _768)) * 0.5) + 0.5) - _752) * CapsulePSConstants.g_fInvNoiseFeather, 0.0, 1.0)) * _752, _1117);
                break;
            }
        } while(false);
        _1131 = _1130;
    }
    else
    {
        _1131 = _752;
    }
    float _1143 = 1.0 - pow(1.0 - clamp((_1131 * CapsulePSConstants.g_xFadeParams.x) + CapsulePSConstants.g_xFadeParams.y, 0.0, 1.0), CapsulePSConstants.g_xFadeParams.z);
    float _1159;
    if (Asura_XRaySkin_ControlConstants.g_bUseExternalRT != 0u)
    {
        _1159 = _1143 * clamp((SAMPLE_TEXTURE(SAMPLER_2D(g_xScreenAlpha, g_xFilteredClamp), gl_FragCoord.xy * FrameConstants.g_xRcpScreenDims).x * 2.0) - 1.0, 0.0, 1.0);
    }
    else
    {
        _1159 = _1143;
    }
    out_var_SV_TARGET = vec4(0.0, 0.0, 0.0, _1159);
}



